/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.js");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/ChunkManager.js":
/*!*****************************!*\
  !*** ./src/ChunkManager.js ***!
  \*****************************/
/*! exports provided: ChunkManager */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ChunkManager", function() { return ChunkManager; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _CulledMesher_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./CulledMesher.js */ "./src/CulledMesher.js");
/* harmony import */ var _VoxelMesh_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./VoxelMesh.js */ "./src/VoxelMesh.js");




class Chunk {
    constructor(data, pos, chunkBits) {
        this.data = data
        this.dims = data.dims
        this.voxels = data.voxels
        this.vmesh = null
        this.surfaceMesh = null
        this.realPosition = pos
        this.chunkPosition = [pos.x, pos.y, pos.z]
        this.id = this.chunkPosition.join('|')
        this.chunkBits = chunkBits
    }

    voxelIndexFromCoordinates(x, y, z) {
        const bits = this.chunkBits
        const mask = (1 << bits) - 1
        return (x & mask) + ((y & mask) << bits) + ((z & mask) << bits * 2)
    }

    voxelAtCoordinates(pt) {
        const vidx = this.voxelIndexFromCoordinates(pt.x, pt.y, pt.z)
        return this.voxels[vidx]
    }
    setVoxelAtCoordinates(pt, val) {
        const vidx = this.voxelIndexFromCoordinates(pt.x, pt.y, pt.z)
        const v = this.voxels[vidx]
        this.voxels[vidx] = val
        return v
    }

    dispose() {
        if (this.vmesh) {
            delete this.vmesh.data
            delete this.vmesh.geometry
            delete this.vmesh.meshed
            delete this.vmesh.surfaceMesh
        }
    }
}

const SCALE = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](1.0,1.0,1.0)

class ChunkManager {
    constructor(opts) {
        this.listeners = {}
        this.container = opts.container
        this.distance = opts.chunkDistance || 2
        this.chunkSize = opts.chunkSize || 32
        this.blockSize = opts.blockSize || 1
        this.generateVoxelChunk = opts.generateVoxelChunk
        this.chunks = {}
        this.mesher = opts.mesher || new _CulledMesher_js__WEBPACK_IMPORTED_MODULE_1__["CulledMesher"]()
        this.textureManager = opts.textureManager

        if (this.chunkSize & this.chunkSize - 1 !== 0)
            throw new Error('chunkSize must be a power of 2')
        if (!this.textureManager)
            throw new Error("missing texture manager")

        //TODO: count the number of bits wide the chunksize is. seems like we could just use Math.log()
        //ex: if chunksize is 16 the bits is 4
        //I think bits is just used for efficient multiplication and division.
        let bits = 0
        for (let size = this.chunkSize; size > 0; size >>= 1) bits++;
        this.chunkBits = bits - 1;
        this.CHUNK_CACHE = {}
    }

    on(type, cb) {
        if(!this.listeners[type]) this.listeners[type] = []
        this.listeners[type].push(cb)
    }
    emit(type,evt) {
        if(!this.listeners[type]) this.listeners[type] = []
        this.listeners[type].forEach(cb => cb(evt))
    }

    clear() {
        Object.keys(this.chunks).forEach(key => {
            const chunk = this.chunks[key]
            this.container.remove(chunk.surfaceMesh)
            chunk.surfaceMesh.geometry.dispose()
            this.CHUNK_CACHE[chunk.id] = chunk.data
            chunk.dispose()
        })
        this.chunks = {}
    }


    // position in chunk indexes?
    nearbyChunks(position, distance) {
        const current = this.chunkAtPosition(position)
        const x = current[0]
        const y = current[1]
        const z = current[2]
        const dist = distance || this.distance
        const nearby = []
        for (let cx = (x - dist); cx !== (x + dist); ++cx) {
            for (let cy = (y - dist); cy !== (y + dist); ++cy) {
                for (let cz = (z - dist); cz !== (z + dist); ++cz) {
                    nearby.push([cx, cy, cz])
                }
            }
        }
        return nearby
    }

    //get missing chunks. position is in world coords
    requestMissingChunks(pos) {
        this.nearbyChunks(pos).map((chunkIndex) => {
            if (!this.chunks[chunkIndex.join('|')]) {
                this.rebuildMesh(this.generateChunk(new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](chunkIndex[0],chunkIndex[1],chunkIndex[2])))
            }
        })
    }

    getBounds(x, y, z) {
        const bits = this.chunkBits
        const low = [x << bits, y << bits, z << bits]
        const high = [(x + 1) << bits, (y + 1) << bits, (z + 1) << bits]
        return [low, high]
    }

    //make a chunk at the position in chunk coords
    generateChunk(pos) {
        const bounds = this.getBounds(pos.x, pos.y, pos.z)
        const id = [pos.x,pos.y,pos.z].join('|')
        let chunkData
        if(this.CHUNK_CACHE[id]) {
            chunkData = this.CHUNK_CACHE[id]
        } else {
            chunkData = this.generateVoxelChunk(bounds[0], bounds[1], pos)
        }
        const chunkObj = new Chunk(chunkData, pos, this.chunkBits)
        this.chunks[chunkObj.id] = chunkObj
        return chunkObj
    }

    makeChunkFromData(info,voxels) {
        const pos = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](info.position[0],info.position[1],info.position[2])
        const chunkData = {
            low:info.low,
            high:info.high,
            voxels:voxels,
            dims:info.dims,
        }
        const chunk = new Chunk(chunkData, pos, this.chunkBits)
        this.chunks[chunk.id] = chunk
        return chunk
    }

    chunkIndexAtCoordinates(x, y, z) {
        const bits = this.chunkBits
        const cx = x >> bits
        const cy = y >> bits
        const cz = z >> bits
        return [cx, cy, cz];
    }

    //position in world coords
    chunkAtPosition(position) {
        const pt = position.divideScalar(this.blockSize).floor()
        return this.chunkIndexAtCoordinates(pt.x, pt.y, pt.z)
    }

    voxelIndexFromCoordinates(x, y, z) {
        const bits = this.chunkBits
        const mask = (1 << bits) - 1
        return (x & mask) + ((y & mask) << bits) + ((z & mask) << bits * 2)
    }

    //get voxel at point in world space
    voxelAtCoordinates(pt) {
        const ckey = this.chunkIndexAtCoordinates(pt.x, pt.y, pt.z).join('|')
        const chunk = this.chunks[ckey]
        if (!chunk) return false
        return chunk.voxelAtCoordinates(pt)
    }

    setVoxelAtCoordinates(pt, val) {
        const ckey = this.chunkIndexAtCoordinates(pt.x, pt.y, pt.z).join('|')
        const chunk = this.chunks[ckey]
        if (!chunk) return false
        const ret = chunk.setVoxelAtCoordinates(pt,val)
        this.rebuildMesh(chunk)
        return ret
    }

    setBlockRange(pos, dim, data) {
        pos.floor()
        const ckey = this.chunkIndexAtCoordinates(pos.x, pos.y, pos.z).join('|')
        const chunk = this.chunks[ckey]
        const pt = pos.clone()
        if(chunk) {
            for(let y=0; y<dim.y; y++) {
                for(let z=0; z<dim.z; z++) {
                    for(let x=0; x<dim.x; x++) {
                        const n = x + z*dim.x + y*dim.x*dim.z
                        const val = data[n]
                        pt.x = pos.x + x
                        pt.y = pos.y + y
                        pt.z = pos.z + z
                        if(val !== -1) this.setVoxelAtCoordinates(pt, val)
                    }
                }
            }
            this.rebuildMesh(chunk)
        }
    }

    //get voxel at position in world coordinates
    voxelAtPosition(pos, val) {
        return this.voxelAtCoordinates(pos.divideScalar(this.blockSize).floor(),val)
    }

    //report the number of chunks currently loaded into memory
    debug_getChunksLoadedCount() {
        return Object.keys(this.chunks).length
    }

    /**
     * remove chunks that are too far away
     * _pos_ is the center of the chunks to look at
     * _group_ is the ThreeJS group that the chunks are stored in
     */
    removeFarChunks(pos) {
        const nearbyChunks = this.nearbyChunks(pos,this.distance+1).map(chunkPos => chunkPos.join('|'))
        Object.keys(this.chunks).map((chunkIndex) => {
            //skip the nearby chunks
            if (nearbyChunks.indexOf(chunkIndex) > -1) return

            const chunk = this.chunks[chunkIndex]
            if (!chunk) return
            this.container.remove(chunk.surfaceMesh)
            chunk.surfaceMesh.geometry.dispose()
            this.CHUNK_CACHE[chunk.id] = chunk.data
            chunk.dispose()
            delete this.chunks[chunkIndex]
        })
    }

    getBlock(x,y,z) {
        return this.voxelAtPosition(new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](x,y,z))
    }

    rebuildMesh(chunk) {
        if(chunk.surfaceMesh) this.container.remove(chunk.surfaceMesh)
        chunk.surfaceMesh = new _VoxelMesh_js__WEBPACK_IMPORTED_MODULE_2__["VoxelMesh"](chunk, this.mesher, SCALE, this)
            .createSurfaceMesh(this.textureManager.material)
        this.container.add(chunk.surfaceMesh)
        const pos = chunk.realPosition.clone().multiplyScalar(this.chunkSize)
        chunk.surfaceMesh.position.copy(pos)
    }
    rebuildAllMeshes() {
        Object.keys(this.chunks).forEach(key => this.rebuildMesh(this.chunks[key]))
    }

    updateCenterPosition(pos) {
        this.requestMissingChunks(pos)
        // and remove the chunks that might be out of range now
        this.removeFarChunks(pos, this.container)
    }
}



/***/ }),

/***/ "./src/CulledMesher.js":
/*!*****************************!*\
  !*** ./src/CulledMesher.js ***!
  \*****************************/
/*! exports provided: CulledMesher */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CulledMesher", function() { return CulledMesher; });
class CulledMesher {
    constructor()
    {

    }

//Naive meshing (with face culling)
    mesh(volume, dims)
    {
        //Precalculate direction vectors for convenience
        var dir = new Array(3)
        for (var i = 0; i < 3; ++i) {
            dir[i] = [[0, 0, 0], [0, 0, 0]]
            dir[i][0][(i + 1) % 3] = 1
            dir[i][1][(i + 2) % 3] = 1
        }
        //March over the volume
        var vertices = []
            , faces = []
            , x = [0, 0, 0]
            , B = [[false, true]    //Incrementally update bounds (this is a bit ugly)
            , [false, true]
            , [false, true]]
            , n = -dims[0] * dims[1]
        for (B[2] = [false, true], x[2] = -1; x[2] < dims[2]; B[2] = [true, (++x[2] < dims[2] - 1)])
            for (n -= dims[0], B[1] = [false, true], x[1] = -1; x[1] < dims[1]; B[1] = [true, (++x[1] < dims[1] - 1)])
                for (n -= 1, B[0] = [false, true], x[0] = -1; x[0] < dims[0]; B[0] = [true, (++x[0] < dims[0] - 1)], ++n) {
                    //Read current voxel and 3 neighboring voxels using bounds check results
                    var p = (B[0][0] && B[1][0] && B[2][0]) ? volume[n] : 0
                        , b = [(B[0][1] && B[1][0] && B[2][0]) ? volume[n + 1] : 0
                        , (B[0][0] && B[1][1] && B[2][0]) ? volume[n + dims[0]] : 0
                        , (B[0][0] && B[1][0] && B[2][1]) ? volume[n + dims[0] * dims[1]] : 0
                    ]
                    //Generate faces
                    for (var d = 0; d < 3; ++d)
                        if ((!!p) !== (!!b[d])) {
                            var s = !p ? 1 : 0
                            var t = [x[0], x[1], x[2]]
                                , u = dir[d][s]
                                , v = dir[d][s ^ 1]
                            ++t[d]

                            var vertex_count = vertices.length
                            vertices.push([t[0], t[1], t[2]])
                            vertices.push([t[0] + u[0], t[1] + u[1], t[2] + u[2]])
                            vertices.push([t[0] + u[0] + v[0], t[1] + u[1] + v[1], t[2] + u[2] + v[2]])
                            vertices.push([t[0] + v[0], t[1] + v[1], t[2] + v[2]])
                            faces.push([vertex_count, vertex_count + 1, vertex_count + 2, vertex_count + 3, s ? b[d] : p])
                        }
                }
        return {vertices: vertices, faces: faces}
    }

}


// if(exports) {
//     exports.mesher = CulledMesh;
// }

/***/ }),

/***/ "./src/DesktopControls.js":
/*!********************************!*\
  !*** ./src/DesktopControls.js ***!
  \********************************/
/*! exports provided: DesktopControls */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DesktopControls", function() { return DesktopControls; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _webxr_boilerplate_Pointer__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./webxr-boilerplate/Pointer */ "./src/webxr-boilerplate/Pointer.js");
/* harmony import */ var _ECSComp_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./ECSComp.js */ "./src/ECSComp.js");
/* harmony import */ var _utils_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./utils.js */ "./src/utils.js");





const LEFT_MOUSE_BUTTON = 1
const RIGHT_MOUSE_BUTTON = 2

class DesktopControls extends _ECSComp_js__WEBPACK_IMPORTED_MODULE_2__["ECSComp"] {

    constructor(app, distance) {
        super()
        this.app = app
        this.distance = distance
        this.canvas = this.app.renderer.domElement
        this.canvas.addEventListener('contextmenu',e => {
            e.preventDefault()
            e.stopPropagation()
        })
        this.canvas.addEventListener('mousemove',e => {
            if(!this.isEnabled()) return
            const pt = new three__WEBPACK_IMPORTED_MODULE_0__["Vector2"](e.clientX,e.clientY)
            const res = Object(_utils_js__WEBPACK_IMPORTED_MODULE_3__["traceRayAtScreenCoords"])(this.app,pt, this.distance)
            res.hitPosition.floor()
            this._fire('highlight',res.hitPosition)
        })
        this.canvas.addEventListener('mousedown',e => {
            if(!this.isEnabled()) return
            const pt = new three__WEBPACK_IMPORTED_MODULE_0__["Vector2"](e.clientX,e.clientY)
            if(e.buttons === LEFT_MOUSE_BUTTON) {
                const res = Object(_utils_js__WEBPACK_IMPORTED_MODULE_3__["traceRayAtScreenCoords"])(this.app, pt, this.distance)
                res.hitPosition.add(res.hitNormal)
                this._fire('setblock',res.hitPosition)
            }
            if(e.buttons === RIGHT_MOUSE_BUTTON) {
                const res = Object(_utils_js__WEBPACK_IMPORTED_MODULE_3__["traceRayAtScreenCoords"])(this.app, pt, this.distance)
                this._fire('removeblock',res.hitPosition)
            }
        })
        this.canvas.addEventListener('mouseup',e => {
        })

        this.pointer = new _webxr_boilerplate_Pointer__WEBPACK_IMPORTED_MODULE_1__["Pointer"](app,{
            //don't intersect with anything. only use for orientation and trigger state
            intersectionFilter: o => o.userData.clickable,
            enableLaser: false,
            mouseSimulatesController:false,
        })
        // this.pointer.disable()
    }
    enable() {
        super.enable()
        // this.pointer.enable()
    }
    disable() {
        super.disable()
        // this.pointer.disable()
    }
    update(time) {
        this.pointer.tick(time)
    }
}


/***/ }),

/***/ "./src/ECSComp.js":
/*!************************!*\
  !*** ./src/ECSComp.js ***!
  \************************/
/*! exports provided: ECSComp */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ECSComp", function() { return ECSComp; });
class ECSComp {
    constructor() {
        this._listeners = {}
        this._enabled = false
    }
    addEventListener(type, cb) {
        if(!this._listeners[type]) this._listeners[type] = []
        this._listeners[type].push(cb)
    }

    _fire(type,payload) {
        if(!this._listeners[type]) this._listeners[type] = []
        this._listeners[type].forEach(cb => cb(payload))
    }

    enable() {
        this._enabled = true
    }

    disable() {
        this._enabled = false
    }

    isEnabled() {
        return this._enabled
    }

    update(time) {

    }


}


/***/ }),

/***/ "./src/FullscreenControls.js":
/*!***********************************!*\
  !*** ./src/FullscreenControls.js ***!
  \***********************************/
/*! exports provided: FullScreenControls */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FullScreenControls", function() { return FullScreenControls; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _raycast_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./raycast.js */ "./src/raycast.js");
/* harmony import */ var _ECSComp_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./ECSComp.js */ "./src/ECSComp.js");
/* harmony import */ var _utils_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./utils.js */ "./src/utils.js");





const HAS_POINTER_LOCK = 'pointerLockElement' in document ||
    'mozPointerLockElement' in document ||
    'webkitPointerLockElement' in document;


function requestPointerLock(el) {
    if(el.requestPointerLock) return el.requestPointerLock()
    console.log("request pointer lock not found")
}


class FullScreenControls extends _ECSComp_js__WEBPACK_IMPORTED_MODULE_2__["ECSComp"] {
    constructor(app) {
        super()
        this.app = app

        this.changeCallback = () => {
            if(document.pointerLockElement) {
                // console.log("entered pointer lock")
            } else {
                // console.log("exited pointer lock")
                this.disable()
            }
        }
        this.moveCallback = (e) => {
            if(!this.isEnabled()) return
            this.app.stageRot.rotation.y += e.movementX/300
            this.app.stageRot.rotation.y += e.movementX/300

            if(e.movementY) {
                this.app.stageRot.rotation.x += e.movementY/500
                this.app.stageRot.rotation.x = Math.max(this.app.stageRot.rotation.x,Object(_utils_js__WEBPACK_IMPORTED_MODULE_3__["toRad"])(-60))
                this.app.stageRot.rotation.x = Math.min(this.app.stageRot.rotation.x,Object(_utils_js__WEBPACK_IMPORTED_MODULE_3__["toRad"])(60))
            }

            const res = this.traceRay()
            res.hitPosition.floor()
            this._fire('highlight',res.hitPosition)
        }
        this.mousedownCallback = (e) => {
            if(!this.isEnabled()) return
            e.preventDefault()
            const LEFT_MOUSE_BUTTON = 1
            const RIGHT_MOUSE_BUTTON = 2
            if(e.buttons === LEFT_MOUSE_BUTTON) {
                const res = this.traceRay()
                res.hitPosition.add(res.hitNormal)
                this._fire('setblock',res.hitPosition)
            }
            if(e.buttons === RIGHT_MOUSE_BUTTON) {
                const res = this.traceRay()
                this._fire('removeblock',res.hitPosition)
            }
        }
        this.errorCallback = (e) => {
            console.log("error getting pointer lock",e)
        }
        this.contextmenuCallback = (e) => {
            e.preventDefault()
            e.stopPropagation()
        }
    }

    traceRay() {
        const target = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,1.6,-1)
        this.app.stagePos.worldToLocal(target)
        const pos = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,1.6,0)
        this.app.stagePos.worldToLocal(pos)
        const ray = new three__WEBPACK_IMPORTED_MODULE_0__["Ray"](pos)
        ray.lookAt(target)

        const hitNormal = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,0,0)
        const hitPosition = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,0,0)
        const hitBlock = Object(_raycast_js__WEBPACK_IMPORTED_MODULE_1__["traceRay"])(this.app.chunkManager,ray.origin,ray.direction,this.distance,hitPosition,hitNormal,_utils_js__WEBPACK_IMPORTED_MODULE_3__["EPSILON"])
        return {
            hitBlock:hitBlock,
            hitPosition:hitPosition,
            hitNormal: hitNormal
        }
    }

    enable() {
        super.enable()
        if(HAS_POINTER_LOCK) {
            // console.log("we have pointer lock")
            document.addEventListener('pointerlockchange',this.changeCallback,false)
            document.addEventListener('mousemove',this.moveCallback,false)
            document.addEventListener('pointerlockerror', this.errorCallback, false);
            document.addEventListener('mousedown',this.mousedownCallback,false)
            document.addEventListener('contextmenu',this.contextmenuCallback,false)
            requestPointerLock(this.app.renderer.domElement)
        }
    }
    disable() {
        if(!this.isEnabled()) return //don't recurse if already disabled
        super.disable()
        document.removeEventListener('pointerlockchange', this.changeCallback, false)
        document.removeEventListener('mousemove', this.moveCallback, false)
        document.removeEventListener('pointerlockerror', this.errorCallback, false);
        document.removeEventListener('contextmenu',this.contextmenuCallback,false)
        this._fire('exit', this)
    }
}



/***/ }),

/***/ "./src/GreedyMesher.js":
/*!*****************************!*\
  !*** ./src/GreedyMesher.js ***!
  \*****************************/
/*! exports provided: GreedyMesher */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "GreedyMesher", function() { return GreedyMesher; });
let mask = new Int32Array(4096);

class GreedyMesher {
    constructor() {
    }

    mesh(volume, dims) {
        var vertices = [], faces = []
            , dimsX = dims[0]
            , dimsY = dims[1]
            , dimsXY = dimsX * dimsY;

        //Sweep over 3-axes
        for (var d = 0; d < 3; ++d) {
            var i, j, k, l, w, W, h, n, c
                , u = (d + 1) % 3
                , v = (d + 2) % 3
                , x = [0, 0, 0]
                , q = [0, 0, 0]
                , du = [0, 0, 0]
                , dv = [0, 0, 0]
                , dimsD = dims[d]
                , dimsU = dims[u]
                , dimsV = dims[v]
                , qdimsX, qdimsXY
                , xd

            if (mask.length < dimsU * dimsV) {
                mask = new Int32Array(dimsU * dimsV);
            }

            q[d] = 1;
            x[d] = -1;

            qdimsX = dimsX * q[1]
            qdimsXY = dimsXY * q[2]

            // Compute mask
            while (x[d] < dimsD) {
                xd = x[d]
                n = 0;

                for (x[v] = 0; x[v] < dimsV; ++x[v]) {
                    for (x[u] = 0; x[u] < dimsU; ++x[u], ++n) {
                        var a = xd >= 0 && volume[x[0] + dimsX * x[1] + dimsXY * x[2]]
                            ,
                            b = xd < dimsD - 1 && volume[x[0] + q[0] + dimsX * x[1] + qdimsX + dimsXY * x[2] + qdimsXY]
                        if (a ? b : !b) {
                            mask[n] = 0;
                            continue;
                        }
                        mask[n] = a ? a : -b;
                    }
                }

                ++x[d];

                // Generate mesh for mask using lexicographic ordering
                n = 0;
                for (j = 0; j < dimsV; ++j) {
                    for (i = 0; i < dimsU;) {
                        c = mask[n];
                        if (!c) {
                            i++;
                            n++;
                            continue;
                        }

                        //Compute width
                        w = 1;
                        while (c === mask[n + w] && i + w < dimsU) w++;

                        //Compute height (this is slightly awkward)
                        for (h = 1; j + h < dimsV; ++h) {
                            k = 0;
                            while (k < w && c === mask[n + k + h * dimsU]) k++
                            if (k < w) break;
                        }

                        // Add quad
                        // The du/dv arrays are reused/reset
                        // for each iteration.
                        du[d] = 0;
                        dv[d] = 0;
                        x[u] = i;
                        x[v] = j;

                        if (c > 0) {
                            dv[v] = h;
                            dv[u] = 0;
                            du[u] = w;
                            du[v] = 0;
                        } else {
                            c = -c;
                            du[v] = h;
                            du[u] = 0;
                            dv[u] = w;
                            dv[v] = 0;
                        }
                        var vertex_count = vertices.length;
                        vertices.push([x[0], x[1], x[2]]);
                        vertices.push([x[0] + du[0], x[1] + du[1], x[2] + du[2]]);
                        vertices.push([x[0] + du[0] + dv[0], x[1] + du[1] + dv[1], x[2] + du[2] + dv[2]]);
                        vertices.push([x[0] + dv[0], x[1] + dv[1], x[2] + dv[2]]);
                        faces.push([vertex_count, vertex_count + 1, vertex_count + 2, vertex_count + 3, c]);

                        //Zero-out mask
                        W = n + w;
                        for (l = 0; l < h; ++l) {
                            for (k = n; k < W; ++k) {
                                mask[k + l * dimsU] = 0;
                            }
                        }

                        //Increment counters and continue
                        i += w;
                        n += w;
                    }
                }
            }
        }
        return {vertices: vertices, faces: faces};
    }
}



/***/ }),

/***/ "./src/KeyboardControls.js":
/*!*********************************!*\
  !*** ./src/KeyboardControls.js ***!
  \*********************************/
/*! exports provided: KeyboardControls */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "KeyboardControls", function() { return KeyboardControls; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ECSComp_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./ECSComp.js */ "./src/ECSComp.js");


const toRad = (deg) => Math.PI / 180 * deg
const Y_AXIS = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,1,0)
const SPEED = 0.1

class KeyboardControls extends _ECSComp_js__WEBPACK_IMPORTED_MODULE_1__["ECSComp"] {
    constructor(app) {
        super()
        this.app = app

        this.keystates = {
            ArrowLeft:{current:false, previous:false},
            ArrowRight:{current:false, previous:false},
            ArrowUp:{current:false, previous:false},
            ArrowDown:{current:false, previous:false},
            a: { current: false, previous: false},
            d: { current: false, previous: false},
            s: { current: false, previous: false},
            w: { current: false, previous: false},
            q: { current: false, previous: false},
            e: { current: false, previous: false},
            Enter: { current: false, previous: false},
            c: { current: false, previous: false},
        }
        this.keystates[' '] = { current: false, previous: false}


        this._keydown_handler = (e)=>{
            if(!this.isEnabled()) return
            if(this.keystates[e.key]) {
                this.keystates[e.key].current = true
            }
        }
        this._keyup_handler = (e)=>{
            if(!this.isEnabled()) return
            if(this.keystates[e.key]) {
                this.keystates[e.key].current = false
            }
        }
        document.addEventListener('keydown',this._keydown_handler)
        document.addEventListener('keyup',this._keyup_handler)
    }

    update(time) {
        if(this.keystates.ArrowUp.current === true)  this.glideForward()
        if(this.keystates.ArrowDown.current === true)  this.glideBackward()
        if(this.keystates.ArrowLeft.current === true)  this.rotateLeft()
        if(this.keystates.ArrowRight.current === true)  this.rotateRight()
        if(this.keystates.a.current === true)  this.glideLeft()
        if(this.keystates.d.current === true)  this.glideRight()
        if(this.keystates.w.current === true)  this.glideForward()
        if(this.keystates.s.current === true)  this.glideBackward()
        if(this.keystates.q.current === true)  this.glideDown()
        if(this.keystates.e.current === true)  this.glideUp()
        if(this.keystates[' '].current === true) this.app.player_phys.startJump()
        if(this.keystates[' '].current === false && this.keystates[' '].previous === true) this.app.player_phys.endJump()

        if(this.keystates.Enter.current === false && this.keystates.Enter.previous === true) {
            this._fire('show-dialog',this)
        }
        if(this.keystates.c.current === true && this.keystates.c.previous === false) {
            this.app.active = !this.app.active
            this.app.player_phys.endFlying()
        }

        Object.keys(this.keystates).forEach(key => {
            this.keystates[key].previous = this.keystates[key].current
        })
    }

    rotateLeft() {
        this.app.stageRot.rotation.y -= toRad(3)
    }

    rotateRight() {
        this.app.stageRot.rotation.y += toRad(3)
    }

    getSpeedDirection() {
        const dir = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,0,1)
        dir.applyAxisAngle(Y_AXIS, -this.app.stageRot.rotation.y)
        return dir.normalize().multiplyScalar(SPEED)
    }
    glideForward() {
        const vel = this.getSpeedDirection().multiplyScalar(-40)
        this.app.player_phys.vel.x = vel.x
        this.app.player_phys.vel.z = vel.z
        this.app.player_phys.markChanged()
    }
    glideBackward() {
        const vel = this.getSpeedDirection().multiplyScalar(40)
        this.app.player_phys.vel.x = vel.x
        this.app.player_phys.vel.z = vel.z
        this.app.player_phys.markChanged()
    }
    glideLeft() {
        const vel = this.getSpeedDirection().multiplyScalar(40).applyAxisAngle(Y_AXIS,toRad(-90))
        this.app.player_phys.vel.x = vel.x
        this.app.player_phys.vel.z = vel.z
        this.app.player_phys.markChanged()
    }
    glideRight() {
        const vel = this.getSpeedDirection().multiplyScalar(40).applyAxisAngle(Y_AXIS,toRad(90))
        this.app.player_phys.vel.x = vel.x
        this.app.player_phys.vel.z = vel.z
        this.app.player_phys.markChanged()
    }

    glideUp() {
        if(!this.app.player_phys.isFlying()) {
            this.app.player_phys.startFlying()
        }
        this.app.player_phys.vel.y = 0.1
        this.app.player_phys.markChanged()
    }
    glideDown() {
        if(!this.app.player_phys.isFlying()) {
            this.app.player_phys.startFlying()
        }
        this.app.player_phys.vel.y = -0.1
        this.app.player_phys.markChanged()
    }
}


/***/ }),

/***/ "./src/PhysHandler.js":
/*!****************************!*\
  !*** ./src/PhysHandler.js ***!
  \****************************/
/*! exports provided: PhysHandler */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PhysHandler", function() { return PhysHandler; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ECSComp_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./ECSComp.js */ "./src/ECSComp.js");


const GRAVITY = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,-9.8,0)

class PhysHandler extends _ECSComp_js__WEBPACK_IMPORTED_MODULE_1__["ECSComp"] {
    constructor(app, target, colliders) {
        super()
        this.app = app
        this.target = target
        this.colliders = colliders
        this.vel = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,0,0)
        this.flying = false
        this.jumping = false
    }
    isFlying() {
        return this.flying
    }
    startFlying() {
        this.flying = true
    }
    endFlying() {
        this.flying = false
    }
    startJump() {
        if(!this.jumping) {
            this.jumping = true
            this.flying = false
            this.jumpTime = Date.now()
        }
    }
    endJump() {
        this.jumping = false
    }
    markChanged() {
        this._fire('move',{position:this.target.position})
    }
    update(time,dt) {
        dt = dt/1000
        // const dt = (time/1000)
        // console.log("tick",dt)
        if(!this.flying && this.app.active) {
            let acc = GRAVITY.y * 0.5
            this.vel.y += acc * dt
        }
        // console.log("now",this.vel.y)
        const pos = this.target.position.clone()
        pos.y += this.vel.y*dt
        pos.z += this.vel.z*dt
        pos.x += this.vel.x*dt
        // console.log(this.vel)
        const diff = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"]()
        diff.y = this.vel.y*dt
        diff.x = this.vel.x*dt
        diff.z = this.vel.z*dt
        this.colliders.forEach(col => {
            col.collide(this,this.target,pos,diff)
        })

        //apply final velocity
        this.target.position.y += this.vel.y
        this.target.position.z += this.vel.z*dt
        this.target.position.x += this.vel.x*dt

        //apply some friction
        this.vel.z *= 0.8
        this.vel.x *= 0.8
        if(this.flying) {
            this.vel.y *= 0.8
        }
        // console.log(this.vel.y)
        this.markChanged()
    }
}


/***/ }),

/***/ "./src/SimpleMeshCollider.js":
/*!***********************************!*\
  !*** ./src/SimpleMeshCollider.js ***!
  \***********************************/
/*! exports provided: checkHitTileY, checkHitTileX, checkHitTileZ, SimpleMeshCollider */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "checkHitTileY", function() { return checkHitTileY; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "checkHitTileX", function() { return checkHitTileX; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "checkHitTileZ", function() { return checkHitTileZ; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SimpleMeshCollider", function() { return SimpleMeshCollider; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);


const SIZE = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"]()
const CENTER = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"]()

function checkHitTileY(voxels, bounds, pos) {
    bounds.getSize(SIZE)
    // console.log("checking for hits near height",SIZE.y)
    //scan in the y direction only for now.
    let sy = Math.floor(pos.y)
    let ey = Math.ceil(pos.y+SIZE.y)
    let sz = Math.floor(pos.z)
    let sx = Math.floor(pos.x)
    let ex = Math.ceil(pos.x+SIZE.x)
    for(let i=sy; i<=ey; i++) {
        // for(let j=sx; j<ex; j++) {
        const vox = voxels.voxelAtCoordinates(new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](sx, i, sz))
        // console.log("hit", vox)
        if (vox > 0) return true
        // }
    }
    return false
}
function checkHitTileX(voxels, bounds, pos) {
    bounds.getCenter(CENTER)
    let sx = Math.floor(pos.x-CENTER.x)
    let ex = Math.ceil(pos.x+CENTER.x)
    let sy = Math.round(pos.y+1)
    let sz = Math.floor(pos.z)
    for(let j=sx; j<ex; j++) {
        const vox = voxels.voxelAtCoordinates(new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](j, sy, sz))
        if (vox > 0) return true
    }
    return false
}
function checkHitTileZ(voxels, bounds, pos) {
    bounds.getCenter(CENTER)
    let sx = Math.floor(pos.x)
    let sy = Math.round(pos.y+1)
    let sz = Math.floor(pos.z-CENTER.z)
    let ez = Math.ceil(pos.z+CENTER.z)
    for(let k=sz; k<ez; k++) {
        const vox = voxels.voxelAtCoordinates(new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](sx, sy, k))
        if (vox > 0) return true
    }
    return false
}

class SimpleMeshCollider {
    constructor(app) {
        this.app = app
    }
    collide(phys, target, pos, diff) {
        //pos is the potential position. we can choose to veto it
        this.app.stagePos.position.y = -target.position.y
        this.app.stagePos.position.z = -target.position.z
        this.app.stagePos.position.x = -target.position.x
        if(!this.app.active) {
            //don't do any physics when the world is paused. just let the user move around
            // phys.vel.y = 0
            return
        }
        //check if too far beyond terminal velocity
        if(phys.vel.y < -1) phys.vel.y = -1


        const bounds = new three__WEBPACK_IMPORTED_MODULE_0__["Box3"](new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,0,0),new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](1,1,1))
        //check downwards
        if(checkHitTileY(this.app.chunkManager,bounds,pos)) {
            if(!phys.isFlying()) {
                phys.vel.y = 0
            }
        }
        //check forwards
        if(checkHitTileX(this.app.chunkManager,bounds,pos)) {
            // console.log("hit something to the left or right")
            phys.vel.x = 0
        }
        if(checkHitTileZ(this.app.chunkManager,bounds,pos)) {
            // console.log("hit something to the front or back")
            phys.vel.z = 0
        }
        //if fell off the world
        if(pos.y < -30) {
            console.log("fell off the world")
            phys.vel.y = 0
            target.position.y = 10
            target.position.x = 0
            target.position.z = 0
        }

        if(phys.jumping) {
            const diff = Date.now() - phys.jumpTime;
            if(diff > 300) {
                // console.log("over one second")
            } else {
                phys.vel.y = 1.0;
            }
        }
    }
}


/***/ }),

/***/ "./src/TextureManager.js":
/*!*******************************!*\
  !*** ./src/TextureManager.js ***!
  \*******************************/
/*! exports provided: TextureManager */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TextureManager", function() { return TextureManager; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);


// const createAtlas = window.atlaspack

/*

* get what I have working w/o the atlas function
* switch to 17 x 17 to address lines
* manually create mip-maps as additional smaller textures

* check out sample3D texture polyfill

*/



class TextureManager {
    constructor(opts) {
        this.canvas = document.createElement('canvas')
        this.canvas.setAttribute('id','texture')
        // document.getElementsByTagName('body')[0].appendChild(this.canvas)
        this.aoEnabled = opts.aoEnabled || false
        this.canvas.width = 128;
        this.canvas.height = 128;
        this.canvas.style.width = '512px';
        this.canvas.style.height = '512px';
        this.tiles = []
        // this.atlas = createAtlas(this.canvas);
        // this.atlas.tilepad = true // this will cost 8x texture memory.
        this.animated = {}
        const ctx = this.canvas.getContext('2d')

        this.texturesEnabled = true
        ctx.fillStyle = 'red'
        ctx.fillRect(0,0,this.canvas.width,this.canvas.height)

        this.texture = new three__WEBPACK_IMPORTED_MODULE_0__["Texture"](this.canvas);
        this.texture.needsUpdate = true
        this.texture.magFilter = three__WEBPACK_IMPORTED_MODULE_0__["NearestFilter"];
        this.texture.minFilter = three__WEBPACK_IMPORTED_MODULE_0__["NearestFilter"];
        this.texturePath =  './textures/';
        this.material = new three__WEBPACK_IMPORTED_MODULE_0__["ShaderMaterial"]( {
            uniforms: {
                'uTime': { value: 0.0 },
                texture: { value: this.texture},
                texturesEnabled: { value: this.texturesEnabled },
            },
            vertexColors:three__WEBPACK_IMPORTED_MODULE_0__["VertexColors"],
            vertexShader: `
            attribute vec2 repeat;
            attribute vec4 subrect;
            attribute float frameCount;
            attribute float occlusion;
            varying vec2 vUv;
            varying vec2 vRepeat;
            varying vec4 vSubrect;
            varying float vFrameCount;
            varying float vOcclusion;
            void main() {
                vUv = uv;
                vSubrect = subrect;
                vRepeat = repeat;
                vFrameCount = frameCount;
                vOcclusion = occlusion;
                vec4 mvPosition = modelViewMatrix * vec4(position,1.0);
                gl_Position = projectionMatrix * mvPosition;
            } 
            `,
            fragmentShader: `
                uniform sampler2D texture;
                uniform float uTime;
                uniform bool texturesEnabled;
                varying vec2 vUv;
                varying vec2 vRepeat;
                varying vec4 vSubrect;
                varying float vFrameCount;
                varying float vOcclusion;
                void main() {
                    vec2 fuv = vUv;
                    vec4 sr = vSubrect;
                    //sr.z = sub rect width
                    //sr.w = sub rect height
                    float frameCount = 3.0;
                    // float cframe = mod(uTime,frameCount);
                    float cframe = mod(uTime,vFrameCount);
                    float cframe2 = floor(cframe); 
                    sr.x = sr.x + cframe2*sr.z;
                    fuv.x = sr.x + fract(vUv.x*vRepeat.x)*sr.z;
                    fuv.y = sr.y + vUv.y*sr.w;
                    vec4 color = vec4(1.0,1.0,1.0,1.0);
                    if(texturesEnabled) {
                        color = texture2D(texture, fuv);
                    }
                    color = color*(vOcclusion);
                    gl_FragColor = vec4(color.xyz,1.0);
                }
            `,
        } );
    }

    packImage(img,index) {
        const info = {
            index:index,
            image:img,
            x:0,
            y:0,
            w:16,
            h:16,
        }
        info.x = (info.index*16)%128 + (info.index)*2 + 1
        info.y = Math.floor(info.index/8)*16 + 1
        const ctx = this.canvas.getContext('2d')
        ctx.imageSmoothingEnabled = false
        //draw image center
        ctx.drawImage(img,info.x,info.y, info.w, info.h)
        //left edge
        ctx.drawImage(img,
            0,0,1,info.h,
            info.x-1,info.y,1,info.h)
        //right edge
        ctx.drawImage(img,
            info.w-1,0,1,info.h,
            info.x+info.w,info.y,1,info.h)
        //top edge
        ctx.drawImage(img,
            0,0,info.w,1,
            info.x,info.y-1,info.w,1)
        ctx.drawImage(img,
            0,info.h-1,info.w,1,
            info.x,info.y+info.h,info.w,1)

        ctx.fillStyle = 'yellow'
        // ctx.fillRect(info.x,info.y,info.w,info.h)
        this.texture.needsUpdate = true
        return info
    }



    isEnabled() {
        return true
    }

    update(ttime) {
        const time = ttime/1000
        this.material.uniforms.uTime.value = time;
        this.material.uniforms.texturesEnabled.value = this.texturesEnabled
    }

    lookupUVsForBlockType(typeNum) {
        const info = this.tiles[typeNum]
        if(!info) {
            const x = 0 / 8.0
            const x2 = 1 / 8.0
            const y = 0
            const y2 = 1 / 8.0
            return [[x, y], [x2, y], [x2, y2], [x, y2]]
        }
        // console.log(x)
        // console.log("looking up type number",typeNum,info)
        const x = info.x/128
        const y = info.y/128
        const x2 = (info.x+info.w)/128
        const y2 = (info.y+info.h)/128
        return [[x,y],[x2,y],[x2,y2],[x,y2]]
        /*
        return [
            [info.x/128,info.y/128],
            [info.x/128,(info.y+info.h)/128],
            [(info.x+info.w)/128,(info.y)/128],
            [(info.x+info.w)/128,(info.y+info.h)/128],
        ]
         */
        // const uvs = this.atlas.uv()[this.names[typeNum-1]]
        // if(!uvs) return [[0,0],[0,1],[1,1],[1,0]]
        // return [[0.0,0],[0.0,1],[0,1],[1,0]]
        // return uvs
    }

    lookupInfoForBlockType(typeNum) {
        return {
            animated:false
        }
    }


    getBlockTypeForName(name) {
        return this.names.findIndex(n => n===name)+1
    }



    loadTextures(infos) {
        const proms = infos.map((info,index) => {
            console.log("loading",info.src)
            return new Promise((res,rej)=>{
                const img = new Image()
                img.id = info.src
                img.src = info.src
                img.onload = () => {
                    res(this.packImage(img,index))
                }
                img.onerror = (e) => {
                    console.error(`Couldn't load texture from url ${infos.src}`)
                    rej(e)
                }
            })
        })
        return Promise.all(proms).then((infos)=>{
            this.tiles = infos
            this.texture.needsUpdate = true
        })
    }

}

function ext(name) {
    return (String(name).indexOf('.') !== -1) ? name : name + '.png';
}


/***/ }),

/***/ "./src/TouchControls.js":
/*!******************************!*\
  !*** ./src/TouchControls.js ***!
  \******************************/
/*! exports provided: TouchControls */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TouchControls", function() { return TouchControls; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ECSComp_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./ECSComp.js */ "./src/ECSComp.js");
/* harmony import */ var _utils_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./utils.js */ "./src/utils.js");




const Y_AXIS = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,1,0)
const SPEED = 0.1


class TouchControls extends _ECSComp_js__WEBPACK_IMPORTED_MODULE_1__["ECSComp"] {
    isTouchEnabled() {
        return ('ontouchstart' in document.documentElement)
    }
    constructor(app, distance, chunkManager) {
        super()
        this.app = app
        this.canvas = this.app.container
        this.distance = distance
        this.chunkManager = chunkManager

        this.dir_button = 'none'

        let point = new three__WEBPACK_IMPORTED_MODULE_0__["Vector2"]()
        let startAngleY = 0
        let startAngleX = 0
        let startTime = 0
        let timeoutID
        let intervalID
        let mode = 'node'
        let currentPoint=  new three__WEBPACK_IMPORTED_MODULE_0__["Vector2"]()
        this.touchStart = (e) => {
            e.preventDefault()
            startAngleY = this.app.stageRot.rotation.y
            startAngleX = this.app.stageRot.rotation.x
            if(e.changedTouches.length <= 0) return
            const tch = e.changedTouches[0]
            point.set(tch.clientX, tch.clientY)
            currentPoint.copy(point)
            startTime = Date.now()
            const res = Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["traceRayAtScreenCoords"])(this.app,point, this.distance)
            res.hitPosition.add(res.hitNormal)
            res.hitPosition.floor()
            this._fire('highlight',res)
            timeoutID = setTimeout(this.startRemoval,1000)
        }
        this.startRemoval = () => {
            mode = 'remove'
            const res = Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["traceRayAtScreenCoords"])(this.app,currentPoint, this.distance)
            res.hitPosition.floor()
            this._fire('highlight',res)
            this._fire('removeblock',res.hitPosition)
            intervalID = setInterval(this.removeAgain,500)
        }
        this.removeAgain = () => {
            const res = Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["traceRayAtScreenCoords"])(this.app, currentPoint, this.distance)
            res.hitPosition.floor()
            this._fire('highlight',res)
            this._fire('removeblock',res.hitPosition)
        }
        this.touchMove = (e) => {
            e.preventDefault()
            if(e.changedTouches.length <= 0) return
            const tch = e.changedTouches[0]
            const pt2 = new three__WEBPACK_IMPORTED_MODULE_0__["Vector2"](tch.clientX, tch.clientY)
            const diffx = pt2.x - point.x
            const diffy = pt2.y - point.y
            this.app.stageRot.rotation.y = +diffx/150 + startAngleY
            this.app.stageRot.rotation.x = +diffy/200 + startAngleX

            currentPoint.copy(pt2)
            const res = Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["traceRayAtScreenCoords"])(this.app, pt2, this.distance)
            if(mode === 'add') {
                res.hitPosition.add(res.hitNormal)
            }
            res.hitPosition.floor()
            this._fire('highlight',res)

            if(this.mode === 'remove') {
                this._fire('removeblock',res.hitPosition)
            }
        }
        this.touchEnd = (e) => {
            e.preventDefault()
            clearTimeout(timeoutID)
            clearInterval(intervalID)
            mode = 'node'
            if(e.changedTouches.length <= 0) return
            const tch = e.changedTouches[0]
            const pt2 = new three__WEBPACK_IMPORTED_MODULE_0__["Vector2"](tch.clientX, tch.clientY)

            const endTime = Date.now()
            if(point.distanceTo(pt2) < 10) {

                const res = Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["traceRayAtScreenCoords"])(this.app, pt2, this.distance)
                if(endTime - startTime > 500) {
                    this._fire('removeblock',res.hitPosition)
                } else {
                    res.hitPosition.add(res.hitNormal)
                    this._fire('setblock', res.hitPosition)
                }
            }
        }

        this.attachButton = (b,dir) => {
            Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["on"])(b,'touchstart',e => {
                e.preventDefault()
                e.stopPropagation()
                this.dir_button = dir
            })
            Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["on"])(b,'touchmove',e => {
                e.preventDefault()
                e.stopPropagation()
            })
            Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["on"])(b,'touchend',e => {
                e.preventDefault()
                e.stopPropagation()
                this.dir_button = _utils_js__WEBPACK_IMPORTED_MODULE_2__["DIRS"].NONE
            })
            Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["on"])(b,'mousedown',e => {
                e.preventDefault()
                this.dir_button = dir
            })
            Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["on"])(b,'mouseup',e => {
                e.preventDefault()
                this.dir_button = _utils_js__WEBPACK_IMPORTED_MODULE_2__["DIRS"].NONE
            })
        }
        this.attachButton (Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["$"])("#left"),_utils_js__WEBPACK_IMPORTED_MODULE_2__["DIRS"].LEFT)
        this.attachButton (Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["$"])("#right"),_utils_js__WEBPACK_IMPORTED_MODULE_2__["DIRS"].RIGHT)
        this.attachButton (Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["$"])("#up"),_utils_js__WEBPACK_IMPORTED_MODULE_2__["DIRS"].UP)
        this.attachButton (Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["$"])("#down"),_utils_js__WEBPACK_IMPORTED_MODULE_2__["DIRS"].DOWN)

        const overlay = Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["$"])("#touch-overlay")
        const menuButton = document.createElement('button')
        menuButton.id = 'menu-button'
        overlay.appendChild(menuButton)
        menuButton.innerText = 'Menu'

        function setupTouchButton(sel,cb) {
            Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["on"])(sel,'touchstart',e => {
                e.preventDefault()
                e.stopPropagation()
            })
            Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["on"])(sel,'touchmove',e => {
                e.preventDefault()
                e.stopPropagation()
            })
            Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["on"])(sel,'touchend',e => {
                e.preventDefault()
                e.stopPropagation()
                cb()
            })
            Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["on"])(sel,'mousedown',e => {
                e.preventDefault()
                e.stopPropagation()
            })
            Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["on"])(sel, 'mouseup', e => {
                e.preventDefault()
                e.stopPropagation()
                cb()
            })
        }
        setupTouchButton(menuButton,()=>this._fire('show-dialog',this))

        const exitButton = document.createElement('button')
        overlay.appendChild(exitButton)
        exitButton.innerText = 'Exit'
        exitButton.id = "exit-fullscreen"
        setupTouchButton(exitButton, ()=>this.app.exitFullscreen())

    }



    update() {
        if(this.dir_button === _utils_js__WEBPACK_IMPORTED_MODULE_2__["DIRS"].LEFT) this.glideLeft()
        if(this.dir_button === _utils_js__WEBPACK_IMPORTED_MODULE_2__["DIRS"].RIGHT) this.glideRight()
        if(this.dir_button === _utils_js__WEBPACK_IMPORTED_MODULE_2__["DIRS"].UP) this.glideForward()
        if(this.dir_button === _utils_js__WEBPACK_IMPORTED_MODULE_2__["DIRS"].DOWN) this.glideBackward()
    }
    enable() {
        super.enable()
        Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["$"])("#touch-overlay").style.display = 'block'
        this.canvas.addEventListener('touchstart',this.touchStart,false)
        this.canvas.addEventListener('touchmove',this.touchMove,false)
        this.canvas.addEventListener('touchend',this.touchEnd,false)
    }
    disable() {
        if(!this.isEnabled()) return //don't recurse if already disabled
        super.disable()
        Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["$"])("#touch-overlay").style.display = 'none'
        this.canvas.removeEventListener('touchstart',this.touchStart)
        this.canvas.removeEventListener('touchmove',this.touchMove)
        this.canvas.removeEventListener('touchend',this.touchEnd)
    }

    glideForward() {
        const vel = this.getSpeedDirection().multiplyScalar(-40)
        this.app.player_phys.vel.x = vel.x
        this.app.player_phys.vel.z = vel.z
        this.app.player_phys.markChanged()
    }
    glideBackward() {
        const vel = this.getSpeedDirection().multiplyScalar(40)
        this.app.player_phys.vel.x = vel.x
        this.app.player_phys.vel.z = vel.z
        this.app.player_phys.markChanged()
    }
    getSpeedDirection() {
        const dir = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,0,1)
        dir.applyAxisAngle(Y_AXIS, -this.app.stageRot.rotation.y)
        return dir.normalize().multiplyScalar(SPEED)
    }
    glideLeft() {
        const vel = this.getSpeedDirection().multiplyScalar(40).applyAxisAngle(Y_AXIS,Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["toRad"])(-90))
        this.app.player_phys.vel.x = vel.x
        this.app.player_phys.vel.z = vel.z
        this.app.player_phys.markChanged()
    }
    glideRight() {
        // this.app.stagePos.position.add(this.getSpeedDirection().applyAxisAngle(Y_AXIS,toRad(-90)))
        const vel = this.getSpeedDirection().multiplyScalar(40).applyAxisAngle(Y_AXIS,Object(_utils_js__WEBPACK_IMPORTED_MODULE_2__["toRad"])(90))
        this.app.player_phys.vel.x = vel.x
        this.app.player_phys.vel.z = vel.z
        this.app.player_phys.markChanged()
    }
}


/***/ }),

/***/ "./src/VRControls.js":
/*!***************************!*\
  !*** ./src/VRControls.js ***!
  \***************************/
/*! exports provided: VRControls */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "VRControls", function() { return VRControls; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _webxr_boilerplate_Pointer__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./webxr-boilerplate/Pointer */ "./src/webxr-boilerplate/Pointer.js");
/* harmony import */ var _raycast_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./raycast.js */ "./src/raycast.js");
/* harmony import */ var _ECSComp_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./ECSComp.js */ "./src/ECSComp.js");
/* harmony import */ var _utils_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./utils.js */ "./src/utils.js");







const Y_AXIS = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,1,0)
const SPEED = 0.1

const TRIGGER = 'trigger'

class VRControls extends _ECSComp_js__WEBPACK_IMPORTED_MODULE_3__["ECSComp"] {

    constructor(app) {
        super()
        this.app = app
        this.distance = 30
        this.states = { touchpad: false}
        
        this.pointer = new _webxr_boilerplate_Pointer__WEBPACK_IMPORTED_MODULE_1__["Pointer"](app,{
            //don't intersect with anything. only use for orientation and trigger state
            intersectionFilter: o => false,
            enableLaser: true,
            mouseSimulatesController:false,
        })
        this.pointer.on(_webxr_boilerplate_Pointer__WEBPACK_IMPORTED_MODULE_1__["POINTER_CLICK"], () => {
            if(!this.isEnabled()) return
            const res = this.traceRay()
            this._fire(TRIGGER,res)
        })

        // this.activeDir = DIRS.NONE
    }

    traceRay() {
        const direction = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0, 0, -1)
        direction.applyQuaternion(this.pointer.controller1.quaternion)
        direction.applyAxisAngle(Y_AXIS,-this.app.stageRot.rotation.y)

        const pos = this.app.stagePos.worldToLocal(this.pointer.controller1.position.clone())

        const epilson = 1e-8
        const hitNormal = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,0,0)
        const hitPosition = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,0,0)
        const hitBlock = Object(_raycast_js__WEBPACK_IMPORTED_MODULE_2__["traceRay"])(this.app.chunkManager,pos,direction,this.distance,hitPosition,hitNormal,epilson)
        return {
            hitBlock:hitBlock,
            hitPosition:hitPosition,
            hitNormal: hitNormal
        }
    }

    rotateLeft() {
        this.app.stageRot.rotation.y -= Object(_utils_js__WEBPACK_IMPORTED_MODULE_4__["toRad"])(30)
    }
    rotateRight() {
        this.app.stageRot.rotation.y += Object(_utils_js__WEBPACK_IMPORTED_MODULE_4__["toRad"])(30)
    }
    getSpeedDirection() {
        const direction = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0, 0, 1)
        //apply the controller rotation to it
        direction.applyQuaternion(this.pointer.controller1.quaternion)
        //apply the stage rotation to it
        direction.applyAxisAngle(Y_AXIS,-this.app.stageRot.rotation.y)
        return direction.normalize().multiplyScalar(SPEED)
    }
    glideBackward() {
        this.app.stagePos.position.add(this.getSpeedDirection().multiplyScalar(-1))
    }
    glideForward() {
        this.app.stagePos.position.add(this.getSpeedDirection())
    }

    update(time) {
        this.scanGamepads(time)
        this.updateCursor(time)
    }

    updateCursor(time) {
        this.pointer.tick(time)
        const res = this.traceRay()
        res.hitPosition.floor()
        this._fire('highlight',res)
    }

    scanGamepads(time) {
        const gamepads = navigator.getGamepads()
        for(let i=0; i<gamepads.length; i++) {
            const gamepad = gamepads[i]
            if ( gamepad && ( gamepad.id === 'Daydream Controller' ||
                gamepad.id === 'Gear VR Controller' || gamepad.id === 'Oculus Go Controller' ||
                gamepad.id === 'OpenVR Gamepad' || gamepad.id.startsWith( 'Oculus Touch' ) ||
                gamepad.id.startsWith( 'Spatial Controller' ) ) ) {
                //we should have at least two buttons
                if(gamepad.buttons.length < 2) return
                this.updateGamepad(gamepad, time)
            }

        }
    }

    updateGamepad(gamepad, time) {
        // const touchpad = gamepad.buttons[0]
        // console.log("axes", gamepad.axes[0], gamepad.axes[1])
        if(!this.states[gamepad.id]) {
            this.states[gamepad.id] = {}
        }



        let newDir = _utils_js__WEBPACK_IMPORTED_MODULE_4__["DIRS"].NONE
        console.log(gamepad.axes[1])
        if(gamepad.axes[1] < -0.5) newDir = _utils_js__WEBPACK_IMPORTED_MODULE_4__["DIRS"].UP
        if(gamepad.axes[1] > +0.5) newDir = _utils_js__WEBPACK_IMPORTED_MODULE_4__["DIRS"].DOWN
        if(gamepad.axes[0] < -0.5) newDir = _utils_js__WEBPACK_IMPORTED_MODULE_4__["DIRS"].LEFT
        if(gamepad.axes[0] > +0.5) newDir = _utils_js__WEBPACK_IMPORTED_MODULE_4__["DIRS"].RIGHT

        let activeDir = this.states[gamepad.id]
        if(!activeDir) activeDir = _utils_js__WEBPACK_IMPORTED_MODULE_4__["DIRS"].NONE
        if(activeDir === _utils_js__WEBPACK_IMPORTED_MODULE_4__["DIRS"].NONE && newDir !== _utils_js__WEBPACK_IMPORTED_MODULE_4__["DIRS"].NONE) {
            if(newDir === _utils_js__WEBPACK_IMPORTED_MODULE_4__["DIRS"].LEFT) {
                this._fire('toggle-pointer',this)
            }
            if(newDir === _utils_js__WEBPACK_IMPORTED_MODULE_4__["DIRS"].RIGHT) {
                this._fire('show-dialog',this)
            }
        }
        if(newDir === _utils_js__WEBPACK_IMPORTED_MODULE_4__["DIRS"].UP) {
            this.glideForward()
        }
        if(newDir === _utils_js__WEBPACK_IMPORTED_MODULE_4__["DIRS"].DOWN) {
            this.glideBackward()
        }


        activeDir = newDir
        this.states[gamepad.id] = activeDir

        // console.log("prev dir",this.activeDir)
        //on click start
        // if(/*touchpad.pressed === true &&*/ this.states.touchpad === false) {
/*            if(gamepad.axes && gamepad.axes.length === 2) {
                // this.activeDir = DIRS.NONE
                if(gamepad.axes[1] < -0.2) this.activeDir = DIRS.UP
                if(gamepad.axes[1] > +0.4) this.activeDir = DIRS.DOWN

                if(this.activeDir === DIRS.NONE) {
                    if(gamepad.axes[0] < -0.5) this.activeDir = DIRS.LEFT
                    if(gamepad.axes[0] > +0.5) this.activeDir = DIRS.RIGHT
                }
            }*/
        // }
        // console.log('new dir', this.activeDir)

        /*
        //on click end
        //left and right clicks
        if(touchpad.pressed === false && this.states.touchpad === true) {
            if(this.activeDir === DIRS.LEFT) {
                // console.log("left click")
                this._fire('toggle-pointer',this)
            }
            if(this.activeDir === DIRS.RIGHT) {
                // console.log("right click")
                this._fire('show-dialog',this)
            }
        }

        //movement
        if(touchpad.pressed) {
            if(this.activeDir === DIRS.UP) {
                // console.log("moving", this.activeDir)
                this.glideForward()
            }
            if(this.activeDir === DIRS.DOWN) {
                // console.log("moving", this.activeDir)
                this.glideBackward()
            }
        }*/

        /*
        //swipe detection
        if(!touchpad.pressed && gamepad.axes[0] < -0.5) {
            if(!this.startRight) {
                this.startLeft = true
                this.timeStart = time
            }
            const diff = time - this.timeStart
            if(this.startRight && diff < 250) {
                // console.log('swiped left')
                this.rotateRight()
            }
            this.startRight = false
        }
        //swipe detection
        if(!touchpad.pressed && gamepad.axes[0] > +0.5) {
            if(!this.startLeft) {
                this.startRight = true
                this.timeStart = time
            }
            const diff = time - this.timeStart
            if(this.startLeft && diff < 250) {
                // console.log('swiped right')
                this.rotateLeft()
            }
            this.startLeft = false
        }
        if(!touchpad.pressed && gamepad.axes[0] === 0 && gamepad.axes[1] === 0) {
            this.startLeft = false
            this.startRight = false
        }
         */

        // this.states.touchpad = touchpad.pressed

    }
}


/***/ }),

/***/ "./src/VRStats.js":
/*!************************!*\
  !*** ./src/VRStats.js ***!
  \************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return VRStats; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ECSComp_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./ECSComp.js */ "./src/ECSComp.js");



class VRStats extends _ECSComp_js__WEBPACK_IMPORTED_MODULE_1__["ECSComp"] {
    constructor(app) {
        super();
        this.app = app
        // this.renderer = renderer
        const can = document.createElement('canvas')
        can.width = 256
        can.height = 128
        this.canvas = can
        const c = can.getContext('2d')
        c.fillStyle = '#00ffff'
        c.fillRect(0,0,can.width,can.height)
        const ctex = new three__WEBPACK_IMPORTED_MODULE_0__["CanvasTexture"](can)
        const mesh = new three__WEBPACK_IMPORTED_MODULE_0__["Mesh"](
            new three__WEBPACK_IMPORTED_MODULE_0__["PlaneGeometry"](1,0.5),
            new three__WEBPACK_IMPORTED_MODULE_0__["MeshBasicMaterial"]({map:ctex})
        )
        mesh.position.z = -3
        mesh.position.y = 2.5
        mesh.material.depthTest = false
        mesh.material.depthWrite = false
        mesh.renderOrder = 1000
        // this.add(mesh)
        this.cmesh = mesh

        this.last = 0
        this.lastFrame = 0
        this.customProps = {}
        this.app.scene.add(mesh)
    }

    update(time) {
        if(time - this.last > 300) {
            // console.log("updating",this.rendereer.info)
            // console.log(`stats calls:`,this.renderer.info)

            const fps = ((this.app.renderer.info.render.frame - this.lastFrame)*1000)/(time-this.last)
            // console.log(fps)

            const c = this.canvas.getContext('2d')
            c.fillStyle = 'white'
            c.fillRect(0, 0, this.canvas.width, this.canvas.height)
            c.fillStyle = 'black'
            c.font = '16pt sans-serif'
            c.fillText(`calls: ${this.app.renderer.info.render.calls}`, 3, 20)
            c.fillText(`tris : ${this.app.renderer.info.render.triangles}`, 3, 40)
            c.fillText(`fps : ${fps.toFixed(2)}`,3,60)
            Object.keys(this.customProps).forEach((key,i) => {
                const val = this.customProps[key]
                c.fillText(`${key} : ${val}`,3,80+i*20)
            })
            this.cmesh.material.map.needsUpdate = true
            this.last = time
            this.lastFrame = this.app.renderer.info.render.frame
        }
    }

    setProperty(name, value) {
        this.customProps[name] = value
    }

}


/***/ }),

/***/ "./src/VoxelMesh.js":
/*!**************************!*\
  !*** ./src/VoxelMesh.js ***!
  \**************************/
/*! exports provided: VoxelMesh */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "VoxelMesh", function() { return VoxelMesh; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);



function generateAmbientOcclusion(grid) {
    return [
        vertexAO(grid[3], grid[1], grid[0])/3.0,
        vertexAO(grid[1], grid[5], grid[2])/3.0,
        vertexAO(grid[5], grid[7], grid[8])/3.0,
        vertexAO(grid[3], grid[7], grid[6])/3.0
    ]
}

function generateGrid(chunkManager,pos,indexes,vertices) {
    const quad = []
    for(let r=0; r<4; r++) {
        quad.push(new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](
            vertices[indexes[r]][0],
            vertices[indexes[r]][1],
            vertices[indexes[r]][2],
            ))
    }

    const ab = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"]()
    ab.copy(quad[1])
    ab.sub(quad[0])

    const ad = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"]()
    ad.copy(quad[3])
    ad.sub(quad[0])

    const anorm = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"]()
    anorm.copy(ab)
    anorm.cross(ad)

    const grid = []
    const pt2 = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"]()
    for(let q=-1; q<2; q++) {
        for(let p=-1;p<2; p++) {
            pt2.copy(pos)
            pt2.x += ab.x * p
            pt2.y += ab.y * p
            pt2.z += ab.z * p
            pt2.x += ad.x * q
            pt2.y += ad.y * q
            pt2.z += ad.z * q
            pt2.x += anorm.x * 1
            pt2.y += anorm.y * 1
            pt2.z += anorm.z * 1
            const type =chunkManager.voxelAtCoordinates(pt2)
            grid.push(type>0?1:0)
        }
    }
    return grid
}

class VoxelMesh {
    constructor(chunk, mesher, scaleFactor, chunkManager) {
        this.data = chunk
        const geometry = this.geometry = new three__WEBPACK_IMPORTED_MODULE_0__["BufferGeometry"]()
        this.scale = scaleFactor || new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](10, 10, 10)

        const result = mesher.mesh(chunk.voxels, chunk.dims)
        this.meshed = result

        //create empty geometry
        const vertices = []
        const repeatUV = []
        const subrects = []

        //copy all verticies in from meshed data
        for (let i = 0; i < result.vertices.length; ++i) {
            let q = result.vertices[i]
            vertices.push(q[0],q[1],q[2])
        }

        const indices = []
        const normaluvs = []
        const frameCount = []
        const occlusion = []
        // if(result.faces.length > 0) console.log(result)
        /*
            generate faces from meshed data

            Note: that quad faces do not use shared vertices. There will always be faces*4 vertices, even
            if some of the faces could share vertices because all attributes are per vertex, and
            those values, such as normals, cannot be shared even if the vertex positions could be.

            each face is represented by two triangles using indexes and one set of uvs (4) for the whole
            face.
        */

        const chunkOffset = chunk.realPosition.clone().multiplyScalar(16)
        for (let i = 0; i < result.faces.length; ++i) {
            let q = result.faces[i]
            const info = chunkManager.textureManager.lookupInfoForBlockType(q[4])
            const realUVs = chunkManager.textureManager.lookupUVsForBlockType(q[4])
            // if(i==0) console.log(realUVs)
            const a = q[0]
            const b = q[1]
            const c = q[2]
            const d = q[3]

            //make two triangles
            /*
                d --- c
                |     |
                a --- b
             */
            indices.push(a,b,d)
            indices.push(b,c,d)
            let repU = 1
            let repV = 1
            const {size, spans} = this.faceVertexUv(i)

            let ao = [1,1,1,1]

            let uv_a = new three__WEBPACK_IMPORTED_MODULE_0__["Vector2"](0,0)
            let uv_b = new three__WEBPACK_IMPORTED_MODULE_0__["Vector2"](1,0)
            let uv_c = new three__WEBPACK_IMPORTED_MODULE_0__["Vector2"](1,1)
            let uv_d = new three__WEBPACK_IMPORTED_MODULE_0__["Vector2"](0,1)

            const pos = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"]()

            if(size.x > 0 && size.y > 0) {
                // console.log("front or back", size, uvs, spans)

                if(spans.x0 > spans.x1) {
                    //calculate AO for back face
                    repU = size.x
                    repV = size.y
                    pos.set(result.vertices[a][0], result.vertices[a][1], result.vertices[a][2])
                    pos.add(chunkOffset)
                    //rotate UVs by 90 degrees
                    normaluvs.push(
                        uv_b.x,uv_b.y,
                        uv_c.x, uv_c.y,
                        uv_d.x,uv_d.y,
                        uv_a.x,uv_a.y,
                    )
                } else {
                    //calculate AO for front face
                    repU = size.x
                    repV = size.y
                    pos.set(result.vertices[a][0], result.vertices[a][1], result.vertices[a][2]-1)
                    pos.add(chunkOffset)
                    //set standard uvs for the whole quad
                    normaluvs.push(
                        uv_a.x,uv_a.y,
                        uv_b.x,uv_b.y,
                        uv_c.x, uv_c.y,
                        uv_d.x,uv_d.y,
                        )
                }
            }


            //top and bottom
            if(size.z > 0 && size.x > 0) {
                if(spans.x0 > spans.x1) {
                    //calculate AO for top face
                    repU = size.z
                    repV = size.x
                    pos.set(result.vertices[a][0], result.vertices[a][1]-1, result.vertices[a][2])
                    pos.add(chunkOffset)
                    //set standard uvs for the whole quad
                    normaluvs.push(
                        uv_a.x, uv_a.y,
                        uv_b.x, uv_b.y,
                        uv_c.x, uv_c.y,
                        uv_d.x, uv_d.y,
                    )
                } else {
                    // bottom
                    repU = size.x
                    repV = size.z
                    pos.set(result.vertices[a][0], result.vertices[a][1], result.vertices[a][2])
                    pos.add(chunkOffset)
                    //set standard uvs for the whole quad
                    normaluvs.push(
                        uv_a.x, uv_a.y,
                        uv_b.x, uv_b.y,
                        uv_c.x, uv_c.y,
                        uv_d.x, uv_d.y,
                    )
                }
            }

            //left and right
            if(size.z > 0 && size.y > 0) {
                if(spans.y0 > spans.y1) {
                    //left side
                    repU = size.z
                    repV = size.y
                    pos.set(result.vertices[a][0], result.vertices[a][1], result.vertices[a][2])
                    pos.add(chunkOffset)
                    //set standard uvs for the whole quad
                    normaluvs.push(uv_a.x,uv_a.y, uv_b.x,uv_b.y, uv_c.x, uv_c.y, uv_d.x,uv_d.y)
                } else {
                    //right side
                    repU = size.z
                    repV = size.y
                    pos.set(result.vertices[a][0]-1, result.vertices[a][1], result.vertices[a][2])
                    pos.add(chunkOffset)
                    //rotate UVs by 90 degrees
                    normaluvs.push(
                        uv_b.x,uv_b.y,
                        uv_c.x,uv_c.y,
                        uv_d.x,uv_d.y,
                        uv_a.x,uv_a.y,
                    )
                }
            }

            if(chunkManager.textureManager.aoEnabled) {
                const grid = generateGrid(chunkManager,pos,q,result.vertices)
                ao = generateAmbientOcclusion(grid)
                occlusion.push(ao[0], ao[1], ao[2], ao[3])
            } else {
                occlusion.push(1,1,1,1)
            }

            for(let j=0; j<4; j++) {
                repeatUV.push(repU, repV);
            }


            const rect = {
                x:realUVs[0][0],
                y:1.0 - realUVs[0][1],
                w:realUVs[1][0] - realUVs[0][0],
                h:realUVs[2][1] - realUVs[1][1],
            }
            // if(i===0) console.log(rect)
            let fc = 1
            if(info.animated) {
                fc = rect.w/rect.h
                rect.w = rect.h
            }
            //flip the y axis properly
            rect.y = 1.0 - realUVs[0][1] - rect.h
            for(let j=0; j<4; j++) {
                subrects.push(rect.x,rect.y,rect.w,rect.h)
            }

            for(let j=0; j<4; j++) {
                frameCount.push(fc)
            }
        }
        geometry.setIndex(indices)
        geometry.addAttribute('position',new three__WEBPACK_IMPORTED_MODULE_0__["Float32BufferAttribute"](vertices,3))
        geometry.addAttribute('uv', new three__WEBPACK_IMPORTED_MODULE_0__["Float32BufferAttribute"](normaluvs,2))
        geometry.addAttribute('subrect',new three__WEBPACK_IMPORTED_MODULE_0__["Float32BufferAttribute"](subrects,4))
        geometry.addAttribute('repeat', new three__WEBPACK_IMPORTED_MODULE_0__["Float32BufferAttribute"](repeatUV,2))
        geometry.addAttribute('frameCount',new three__WEBPACK_IMPORTED_MODULE_0__["Float32BufferAttribute"](frameCount,1))
        geometry.addAttribute('occlusion',new three__WEBPACK_IMPORTED_MODULE_0__["Float32BufferAttribute"](occlusion,1))

        geometry.computeFaceNormals()
        geometry.uvsNeedUpdate = true
        geometry.verticesNeedUpdate = true
        geometry.elementsNeedUpdate = true
        geometry.normalsNeedUpdate = true

        geometry.computeBoundingBox()
        geometry.computeBoundingSphere()

    }

    createSurfaceMesh(material) {
        const surfaceMesh = new three__WEBPACK_IMPORTED_MODULE_0__["Mesh"](this.geometry, material)
        surfaceMesh.scale.copy(this.scale)
        this.surfaceMesh = surfaceMesh
        return surfaceMesh
    }

    faceVertexUv(i) {
        let height
        let width
        const vs = [
            this.meshed.vertices[i * 4 + 0],
            this.meshed.vertices[i * 4 + 1],
            this.meshed.vertices[i * 4 + 2],
            this.meshed.vertices[i * 4 + 3]
        ]
        const spans = {
            x0: vs[0][0] - vs[1][0],
            x1: vs[1][0] - vs[2][0],
            y0: vs[0][1] - vs[1][1],
            y1: vs[1][1] - vs[2][1],
            z0: vs[0][2] - vs[1][2],
            z1: vs[1][2] - vs[2][2]
        }
        const size = {
            x: Math.max(Math.abs(spans.x0), Math.abs(spans.x1)),
            y: Math.max(Math.abs(spans.y0), Math.abs(spans.y1)),
            z: Math.max(Math.abs(spans.z0), Math.abs(spans.z1))
        }

        if (size.x === 0) {
            if (spans.y0 > spans.y1) {
                width = size.y
                height = size.z
            } else {
                width = size.z
                height = size.y
            }
        }
        if (size.y === 0) {
            if (spans.x0 > spans.x1) {
                width = size.x
                height = size.z
            } else {
                width = size.z
                height = size.x
            }
        }
        if (size.z === 0) {
            if (spans.x0 > spans.x1) {
                width = size.x
                height = size.y
            } else {
                width = size.y
                height = size.x
            }
        }

    /*
        let uvs = []
        if ((size.z === 0 && spans.x0 < spans.x1) || (size.x === 0 && spans.y0 > spans.y1)) {
            uvs = [
                new Vector2(height, 0),
                new Vector2(0, 0),
                new Vector2(0, width),
                new Vector2(height, width)
            ]
        } else {
            uvs = [
                new Vector2(0, 0),
                new Vector2(0, height),
                new Vector2(width, height),
                new Vector2(width, 0)
            ]
        }
        */
        return {size, spans}

    }
}


function vertexAO(side1, side2, corner) {
    if(side1 && side2) {
        return 0
    }
    return 3 - (side1 + side2 + corner)
}


/***/ }),

/***/ "./src/VoxelTexture.js":
/*!*****************************!*\
  !*** ./src/VoxelTexture.js ***!
  \*****************************/
/*! exports provided: VoxelTexture */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "VoxelTexture", function() { return VoxelTexture; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);
// var isTransparent = require('opaque').transparent;



const createAtlas = window.atlaspack

class VoxelTexture {
    constructor(opts) {
        this.game = opts.game;
        delete opts.game;
        this.materials = [];
        this.transparents = [];
        this.texturePath = opts.texturePath || '/textures/';
        this.loading = 0;
        // this.ao = require('voxel-fakeao')(this.game);

        var useFlatColors = opts.materialFlatColor === true;
        delete opts.materialFlatColor;

        this.options = defaults(opts || {}, {
            crossOrigin: 'Anonymous',
            materialParams: defaults(opts.materialParams || {}, {
                ambient: 0xbbbbbb,
                transparent: false,
                side: three__WEBPACK_IMPORTED_MODULE_0__["DoubleSide"],
            }),
            materialTransparentParams: defaults(opts.materialTransparentParams || {}, {
                ambient: 0xbbbbbb,
                transparent: true,
                side: three__WEBPACK_IMPORTED_MODULE_0__["DoubleSide"],
                //depthWrite: false,
                //depthTest: false
            }),
            materialType: three__WEBPACK_IMPORTED_MODULE_0__["MeshLambertMaterial"],
            applyTextureParams: function (map) {
                map.magFilter = three__WEBPACK_IMPORTED_MODULE_0__["NearestFilter"];
                map.minFilter = three__WEBPACK_IMPORTED_MODULE_0__["LinearMipMapLinearFilter"];
            }
        });

        // create a canvas for the texture atlas
        this.canvas = (typeof document !== 'undefined') ? document.createElement('canvas') : {};
        this.canvas.width = opts.atlasWidth || 512;
        this.canvas.height = opts.atlasHeight || 512;
        var ctx = this.canvas.getContext('2d');
        ctx.fillStyle = 'black';
        ctx.fillRect(0, 0, this.canvas.width, this.canvas.height);

        // create core atlas and texture
        this.atlas = createAtlas(this.canvas);
        this.atlas.tilepad = true;
        this._atlasuv = false;
        this._atlaskey = false;
        this.texture = new three__WEBPACK_IMPORTED_MODULE_0__["Texture"](this.canvas);
        this.options.applyTextureParams(this.texture);

        if (useFlatColors) {
            // If were using simple colors
            this.material = new three__WEBPACK_IMPORTED_MODULE_0__["MeshBasicMaterial"]({
                vertexColors: three__WEBPACK_IMPORTED_MODULE_0__["FaceColors"]
            });
        } else {
            var opaque = new this.options.materialType(this.options.materialParams);
            opaque.map = this.texture;
            // var transparent = new this.options.materialType(this.options.materialTransparentParams);
            // transparent.map = this.texture;
            this.material = opaque
            // this.material = new MeshFaceMaterial([
            //     opaque,
            //     transparent
            // ]);
        }

        // a place for meshes to wait while textures are loading
        this._meshQueue = [];
    }

    load(names, done) {
        if (!Array.isArray(names)) names = [names];
        done = done || function () {
        };
        this.loading++;

        var materialSlice = names.map(this._expandName);
        this.materials = this.materials.concat(materialSlice);

        // load onto the texture atlas
        var load = Object.create(null);
        materialSlice.forEach(function (mats) {
            mats.forEach(function (mat) {
                if (mat.slice(0, 1) === '#') return;
                // todo: check if texture already exists
                load[mat] = true;
            });
        });
        if (Object.keys(load).length > 0) {
            each(Object.keys(load), this.pack.bind(this), () => {
                this._afterLoading();
                done(materialSlice);
            });
        } else {
            this._afterLoading();
        }
    };

    pack(name, done) {
        const self = this

        function pack(img) {
            var node = self.atlas.pack(img);
            if (node === false) {
                self.atlas = self.atlas.expand(img);
                self.atlas.tilepad = true;
            }
            done();
        }

        if (typeof name === 'string') {
            var img = new Image();
            img.id = name;
            img.crossOrigin = this.options.crossOrigin;
            img.src = this.texturePath + ext(name);
            img.onload = function () {
                // if (isTransparent(img)) {
                //   self.transparents.push(name);
                // }
                pack(img);
            };
            img.onerror = function () {
                console.error('Couldn\'t load URL [' + img.src + ']');
                done();
            };
        } else {
            pack(name);
        }
        return this;
    };

    find(name) {
        var type = 0;
        this.materials.forEach(function (mats, i) {
            mats.forEach(function (mat) {
                if (mat === name) {
                    type = i + 1;
                    return false;
                }
            });
            if (type !== 0) return false;
        });
        return type;
    };


    _expandName(name) {
        if (name === null) return Array(6);
        if (name.top) return [name.back, name.front, name.top, name.bottom, name.left, name.right];
        if (!Array.isArray(name)) name = [name];
        // load the 0 texture to all
        if (name.length === 1) name = [name[0], name[0], name[0], name[0], name[0], name[0]];
        // 0 is top/bottom, 1 is sides
        if (name.length === 2) name = [name[1], name[1], name[0], name[0], name[1], name[1]];
        // 0 is top, 1 is bottom, 2 is sides
        if (name.length === 3) name = [name[2], name[2], name[0], name[1], name[2], name[2]];
        // 0 is top, 1 is bottom, 2 is front/back, 3 is left/right
        if (name.length === 4) name = [name[2], name[2], name[0], name[1], name[3], name[3]];
        return name;
    };

    _afterLoading() {
        const alldone = () => {
            this.loading--;
            this._atlasuv = this.atlas.uv(this.canvas.width, this.canvas.height);
            this._atlaskey = Object.create(null);
            this.atlas.index().forEach((key) => {
                this._atlaskey[key.name] = key;
            });
            this.texture.needsUpdate = true;
            this.material.needsUpdate = true;
            //window.open(this.canvas.toDataURL());
            if (this._meshQueue.length > 0) {
                this._meshQueue.forEach((queue, i) => {
                    this.paint.apply(queue.self, queue.args);
                    delete this._meshQueue[i];
                });
            }
        }

        this._powerof2(function () {
            setTimeout(alldone, 100);
        });
    };

// Ensure the texture stays at a power of 2 for mipmaps
// this is cheating :D
    _powerof2(done) {
        var w = this.canvas.width;
        var h = this.canvas.height;

        function pow2(x) {
            x--;
            x |= x >> 1;
            x |= x >> 2;
            x |= x >> 4;
            x |= x >> 8;
            x |= x >> 16;
            x++;
            return x;
        }

        if (h > w) w = h;
        var old = this.canvas.getContext('2d').getImageData(0, 0, this.canvas.width, this.canvas.height);
        this.canvas.width = this.canvas.height = pow2(w);
        this.canvas.getContext('2d').putImageData(old, 0, 0);
        done();
    };

    paint(mesh, materials) {
        var self = this;
        // if were loading put into queue
        if (this.loading > 0) {
            this._meshQueue.push({self: this, args: arguments});
            return false;
        }

        var isVoxelMesh = (materials) ? false : true;
        if (!isVoxelMesh) materials = this._expandName(materials);

        // mesh.material.vertexColors = FaceColors
        // mesh.material.flatShading = true
        mesh.geometry.faces.forEach((face, i) => {
            if (mesh.geometry.faceVertexUvs[0].length < 1) return;

            if (isVoxelMesh) {
                var index = Math.floor(face.color.b*255 + face.color.g*255*255 + face.color.r*255*255*255);
                materials = this.materials[index - 1];
                if (!materials) materials = this.materials[0];
            }

            // BACK, FRONT, TOP, BOTTOM, LEFT, RIGHT
            var name = materials[0] || '';
            if      (face.normal.z === 1)  name = materials[1] || '';
            else if (face.normal.y === 1)  name = materials[2] || '';
            else if (face.normal.y === -1) name = materials[3] || '';
            else if (face.normal.x === -1) name = materials[4] || '';
            else if (face.normal.x === 1)  name = materials[5] || '';

            // if just a simple color
            if (name.slice(0, 1) === '#') {
                face.color = new three__WEBPACK_IMPORTED_MODULE_0__["Color"](name)
                return;
            }

            var atlasuv = this._atlasuv[name];
            if (!atlasuv) return;

            // If a transparent texture use transparent material
            face.materialIndex = (self.transparents.indexOf(name) !== -1) ? 1 : 0;

            // 0 -- 1
            // |    |
            // 3 -- 2
            // faces on these meshes are flipped vertically, so we map in reverse
            // TODO: tops need rotate
            if (isVoxelMesh) {
                if (face.normal.z === -1 || face.normal.x === 1) {
                    atlasuv = uvrot(atlasuv, 90);
                }
                atlasuv = uvinvert(atlasuv);
            } else {
                atlasuv = uvrot(atlasuv, -90);
            }
            //use different indexes for even and odd.
            if(i%2 === 0) {
                for (var j = 0; j < mesh.geometry.faceVertexUvs[0][i].length; j++) {
                    let n = j
                    if(j === 0) n = 0;
                    if(j === 1) n = 1;
                    if(j === 2) n = 3
                    mesh.geometry.faceVertexUvs[0][i][j].x = atlasuv[n][0]
                    mesh.geometry.faceVertexUvs[0][i][j].y = 1 - atlasuv[n][1]
                }
            } else {
                for (let j = 0; j < mesh.geometry.faceVertexUvs[0][i].length; j++) {
                    mesh.geometry.faceVertexUvs[0][i][j].x = atlasuv[j+1][0]
                    mesh.geometry.faceVertexUvs[0][i][j].y = 1 - atlasuv[j+1][1]
                }
            }
        });

        mesh.geometry.elementsNeedUpdate = true
        mesh.geometry.uvsNeedUpdate = true;
    };

    sprite(name, w, h, cb) {
        if (typeof w === 'function') {
            cb = w;
            w = null;
        }
        if (typeof h === 'function') {
            cb = h;
            h = null;
        }
        w = w || 16;
        h = h || w;
        this.loading++;
        var img = new Image();
        img.src = this.texturePath + ext(name);
        img.onerror = cb;
        img.onload = function () {
            var canvases = [];
            for (var x = 0; x < img.width; x += w) {
                for (var y = 0; y < img.height; y += h) {
                    var canvas = document.createElement('canvas');
                    canvas.width = w;
                    canvas.height = h;
                    canvas.name = name + '_' + x + '_' + y;
                    canvas.getContext('2d').drawImage(img, x, y, w, h, 0, 0, w, h);
                    canvases.push(canvas);
                }
            }
            var textures = [];
            each(canvases, function (canvas, next) {
                var tex = new Image();
                tex.name = canvas.name;
                tex.src = canvas.toDataURL();
                tex.onload = function () {
                    this.pack(tex, next);
                };
                tex.onerror = next;
                textures.push([
                    tex.name, tex.name, tex.name,
                    tex.name, tex.name, tex.name
                ]);
            }, function () {
                this._afterLoading();
                // delete canvases;
                this.materials = this.materials.concat(textures);
                cb(textures);
            });
        };
        return this;
    };

    animate(mesh, names, delay) {
        delay = delay || 1000;
        if (!Array.isArray(names) || names.length < 2) return false;
        var i = 0;
        var mat = new this.options.materialType(this.options.materialParams);
        mat.map = this.texture;
        mat.transparent = true;
        mat.needsUpdate = true;
        // tic.interval(function() {
        //   this.paint(mesh, names[i % names.length]);
        //   i++;
        // }, delay);
        return mat;
    };

    tick(dt) {
        // tic.tick(dt);
    };
}

function uvrot(coords, deg) {
    if (deg === 0) return coords;
    var c = [];
    var i = (4 - Math.ceil(deg / 90)) % 4;
    for (var j = 0; j < 4; j++) {
        c.push(coords[i]);
        if (i === 3) i = 0; else i++;
    }
    return c;
}

function uvinvert(coords) {
    var c = coords.slice(0);
    return [c[3], c[2], c[1], c[0]];
}

function ext(name) {
    return (String(name).indexOf('.') !== -1) ? name : name + '.png';
}

function defaults(obj) {
    [].slice.call(arguments, 1).forEach(function (from) {
        if (from) for (var k in from) if (obj[k] == null) obj[k] = from[k];
    });
    return obj;
}

function each(arr, it, done) {
    var count = 0;
    arr.forEach(function (a) {
        it(a, function () {
            count++;
            if (count >= arr.length) done();
        });
    });
}


/***/ }),

/***/ "./src/ecsy/camera_gimbal.js":
/*!***********************************!*\
  !*** ./src/ecsy/camera_gimbal.js ***!
  \***********************************/
/*! exports provided: StagePosition, StageRotation */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "StagePosition", function() { return StagePosition; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "StageRotation", function() { return StageRotation; });
class StagePosition {}
class StageRotation {}


/***/ }),

/***/ "./src/ecsy/dashboard.js":
/*!*******************************!*\
  !*** ./src/ecsy/dashboard.js ***!
  \*******************************/
/*! exports provided: DomDashboard, DashboardVisible, DashboardDOMOvleraySystem */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DomDashboard", function() { return DomDashboard; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DashboardVisible", function() { return DashboardVisible; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DashboardDOMOvleraySystem", function() { return DashboardDOMOvleraySystem; });
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ecsy */ "ecsy");
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(ecsy__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _voxels_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./voxels.js */ "./src/ecsy/voxels.js");
/* harmony import */ var _highlight_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./highlight.js */ "./src/ecsy/highlight.js");
/* harmony import */ var _input_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./input.js */ "./src/ecsy/input.js");





class DomDashboard extends ecsy__WEBPACK_IMPORTED_MODULE_0__["Component"] {
    constructor() {
        super();
        this.domElement = null
    }
}

class DashboardVisible extends ecsy__WEBPACK_IMPORTED_MODULE_0__["Component"] {

}

class DashboardDOMOvleraySystem extends ecsy__WEBPACK_IMPORTED_MODULE_0__["System"] {
    execute(delta, time) {
        this.queries.dash.added.forEach(me=>{
            const dash = me.getComponent(DomDashboard);
            let div = document.createElement('div');
            div.classList.add("dom-dashboard");
            div.addEventListener('mousedown',e => e.stopPropagation());
            div.addEventListener('mouseup',e => e.stopPropagation());
            div.addEventListener('mousemove',e => e.stopPropagation());
            document.documentElement.append(div)

            this.queries.textures.results.forEach(ent => {
                console.log("textures are", ent.getComponent(_voxels_js__WEBPACK_IMPORTED_MODULE_1__["VoxelTextures"]))
                let texs = ent.getComponent(_voxels_js__WEBPACK_IMPORTED_MODULE_1__["VoxelTextures"]).textures
                texs.forEach((tex,i) => {
                    console.log("adding texture",tex);
                    let img = document.createElement('img')
                    img.src = tex.src;
                    div.append(img);
                    img.addEventListener('click',(e)=>{
                        e.preventDefault();
                        e.stopPropagation()
                        console.log(`chose this image ${i}`,i)
                        this.queries.active.results.forEach(ent=>{
                            ent.getMutableComponent(_highlight_js__WEBPACK_IMPORTED_MODULE_2__["ActiveBlock"]).type = i
                        })
                    })
                })
            })
            let dismiss = document.createElement('button');
            dismiss.innerHTML = "dismiss"
            dismiss.addEventListener('click',()=>{
                this.queries.visible.results.forEach(ent => {
                    ent.removeComponent(DashboardVisible)
                })
            })
            div.append(dismiss)
            dash.domElement = div
        })
        this.queries.input.results.forEach(ent => {
            let input = ent.getComponent(_input_js__WEBPACK_IMPORTED_MODULE_3__["InputFrame"])
            if (input.state[_input_js__WEBPACK_IMPORTED_MODULE_3__["InputFrame"].OPEN_DASHBOARD] === true) {
                this.queries.dash.results.forEach(dash_ent => {
                    if(!dash_ent.hasComponent(DashboardVisible)) {
                        dash_ent.addComponent(DashboardVisible)
                    }
                })
            }
        })
        this.queries.visible.added.forEach(ent => {
            console.log("made visible")
            ent.getMutableComponent(DomDashboard).domElement.classList.add('visible')
        })
        this.queries.visible.removed.forEach(ent => {
            console.log("made in-visible")
            ent.getMutableComponent(DomDashboard).domElement.classList.remove('visible')
        })
    }
}
DashboardDOMOvleraySystem.queries = {
    dash: {
        components:[DomDashboard],
        listen: {
            added:true,
        }
    },
    visible: {
        components:[DashboardVisible, DomDashboard],
        listen: {
            added:true,
            removed:true,
        }
    },
    input: {
        components:[_input_js__WEBPACK_IMPORTED_MODULE_3__["InputFrame"]]
    },
    textures: {
        components:[_voxels_js__WEBPACK_IMPORTED_MODULE_1__["VoxelTextures"]],
    },
    active: {
        components:[_highlight_js__WEBPACK_IMPORTED_MODULE_2__["ActiveBlock"]]
    },
}



/***/ }),

/***/ "./src/ecsy/fullscreen.js":
/*!********************************!*\
  !*** ./src/ecsy/fullscreen.js ***!
  \********************************/
/*! exports provided: FullscreenMode, FullscreenButton, FullscreenSystem */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FullscreenMode", function() { return FullscreenMode; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FullscreenButton", function() { return FullscreenButton; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FullscreenSystem", function() { return FullscreenSystem; });
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ecsy */ "ecsy");
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(ecsy__WEBPACK_IMPORTED_MODULE_0__);


class FullscreenMode extends ecsy__WEBPACK_IMPORTED_MODULE_0__["Component"] {

}
class FullscreenButton extends ecsy__WEBPACK_IMPORTED_MODULE_0__["Component"] {

}
/*
        this.fullscreenchangeHandler = () => {
            if(document.fullscreenElement) return this._fire(FULLSCREEN_ENTERED, this)
            if(document.webkitFullscreenElement) return this._fire(FULLSCREEN_ENTERED, this)
            this._fire(FULLSCREEN_EXITED,this)
        }
        document.addEventListener('fullscreenchange',this.fullscreenchangeHandler)
        document.addEventListener('webkitfullscreenchange',this.fullscreenchangeHandler)

    playFullscreen() {
        this.resizeOnNextRepaint = true
        this.container.requestFullscreen()
    }

    exitFullscreen() {
        this.resizeOnNextRepaint = true
        if(document.exitFullscreen) document.exitFullscreen()
        if(document.webkitExitFullscreen) document.webkitExitFullscreen()
    }


 */
class FullscreenSystem extends  ecsy__WEBPACK_IMPORTED_MODULE_0__["System"] {
    execute(delta, time) {
        this.queries.buttons.added.forEach(ent => {
            let elem = document.createElement('button')
            elem.innerText = "fullscreen"
            elem.classList.add("fullscreen")
            elem.addEventListener('click',(e)=>{
                e.stopPropagation()
                e.preventDefault()
                ent.addComponent(FullscreenMode);
            })
            document.documentElement.append(elem);
        })
        this.queries.active.added.forEach(ent => {
            console.log("turned on full screen")
            this.fullscreenchangeHandler = () => {
                console.log("entered full screen")
                if(document.fullscreenElement || document.webkitFullscreenElement) {
                    console.log("entered")
                } else {
                    console.log("exited")
                }
            }
            document.addEventListener('fullscreenchange',this.fullscreenchangeHandler)
            document.addEventListener('webkitfullscreenchange',this.fullscreenchangeHandler)
            const domElement = document.querySelector("canvas")
            domElement.requestFullscreen()
        })
    }
}
FullscreenSystem.queries = {
    buttons: {
        components: [FullscreenButton],
        listen: {
            added:true
        }
    },
    active: {
        components: [FullscreenMode],
        listen: {
            added:true,
        }
    }
}


/***/ }),

/***/ "./src/ecsy/highlight.js":
/*!*******************************!*\
  !*** ./src/ecsy/highlight.js ***!
  \*******************************/
/*! exports provided: Highlight, ActiveBlock, HighlightSystem */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Highlight", function() { return Highlight; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ActiveBlock", function() { return ActiveBlock; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "HighlightSystem", function() { return HighlightSystem; });
/* harmony import */ var _utils_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../utils.js */ "./src/utils.js");
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ecsy */ "ecsy");
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(ecsy__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var ecsy_three__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ecsy-three */ "ecsy-three");
/* harmony import */ var ecsy_three__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(ecsy_three__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _raycast_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../raycast.js */ "./src/raycast.js");
/* harmony import */ var _camera_gimbal_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./camera_gimbal.js */ "./src/ecsy/camera_gimbal.js");
/* harmony import */ var _mouse_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./mouse.js */ "./src/ecsy/mouse.js");
/* harmony import */ var _voxels_js__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./voxels.js */ "./src/ecsy/voxels.js");
/* harmony import */ var _input_js__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./input.js */ "./src/ecsy/input.js");










class Highlight {
}
class ActiveBlock {
    constructor() {
        this.type = 1;
    }
}


class HighlightSystem extends ecsy__WEBPACK_IMPORTED_MODULE_1__["System"] {
    init() {
    }
    traceRayAtScreenCoords(
        stageRot, stagePos, domElement, camera,
        chunkManager, pt, distance) {
        const ray = new three__WEBPACK_IMPORTED_MODULE_2__["Ray"]()

        // e = e.changedTouches[0]
        const mouse = new three__WEBPACK_IMPORTED_MODULE_2__["Vector2"]()
        const bounds = domElement.getBoundingClientRect()
        mouse.x = ((pt.x - bounds.left) / bounds.width) * 2 - 1
        mouse.y = -((pt.y - bounds.top) / bounds.height) * 2 + 1

        ray.origin.copy(camera.position)
        ray.direction.set(mouse.x, mouse.y, 0.5).unproject(camera).sub(ray.origin).normalize()
        // console.log("new bounds is",mouse,camera)
        // console.log("stage pos is",stagePos)

        stagePos.worldToLocal(ray.origin)
        ray.origin.add(new three__WEBPACK_IMPORTED_MODULE_2__["Vector3"](0,0,-0.5))
        const quat = new three__WEBPACK_IMPORTED_MODULE_2__["Quaternion"]()
        quat.copy(stageRot.quaternion)
        quat.inverse()
        ray.direction.applyQuaternion(quat)

        const hitNormal = new three__WEBPACK_IMPORTED_MODULE_2__["Vector3"](0,0,0)
        const hitPosition = new three__WEBPACK_IMPORTED_MODULE_2__["Vector3"](0,0,0)
        // console.log("chunk manager is", chunkManager)
        const hitBlock = Object(_raycast_js__WEBPACK_IMPORTED_MODULE_4__["traceRay"])(chunkManager,ray.origin,ray.direction,distance,hitPosition,hitNormal,_utils_js__WEBPACK_IMPORTED_MODULE_0__["EPSILON"])
        return {
            hitBlock:hitBlock,
            hitPosition:hitPosition,
            hitNormal: hitNormal
        }
    }
    execute(delta,time) {
        this.queries.mouse.results.forEach(mousEnt => {
            let mouse = mousEnt.getComponent(_mouse_js__WEBPACK_IMPORTED_MODULE_6__["MouseCursor"])
            let stageRot = this.queries.stageRot.results[0].getComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_3__["Object3D"]).value
            let stagePos = this.queries.stagePos.results[0].getComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_3__["Object3D"]).value;
            this.queries.landscape.results.forEach(ent=>{
                const landscape = ent.getComponent(_voxels_js__WEBPACK_IMPORTED_MODULE_7__["VoxelLandscape"]);
                this.queries.highlights.results.forEach(ent => {
                    // console.log("checking",mouse.position, stageRot, stagePos);
                    const domElement = document.querySelector("canvas")
                    const camera = this.queries.camera.results[0].getComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_3__["Object3D"]).value
                    const distance = 10;

                    const res = this.traceRayAtScreenCoords(
                        stageRot, stagePos, domElement, camera,
                        landscape.chunkManager, mouse.position, distance)
                    //console.log("res is",res);
                    res.hitPosition.floor()

                    //move the highlight
                    let tran = ent.getMutableComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_3__["Transform"]);
                    tran.position.copy(res.hitPosition)

                    //if left button
                    this.queries.inputs.results.forEach(ent => {
                        let input = ent.getComponent(_input_js__WEBPACK_IMPORTED_MODULE_8__["InputFrame"])
                        if(input.state[_input_js__WEBPACK_IMPORTED_MODULE_8__["InputFrame"].CREATE_AT_CURSOR] === true) {
                            let pos = res.hitPosition.clone()
                            pos.add(res.hitNormal)
                            pos.floor()
                            let active = this.queries.active.results[0]
                            landscape.chunkManager.setVoxelAtCoordinates(pos,active.getComponent(ActiveBlock).type)
                        }
                        input.state[_input_js__WEBPACK_IMPORTED_MODULE_8__["InputFrame"].CREATE_AT_CURSOR] = false
                        if(input.state[_input_js__WEBPACK_IMPORTED_MODULE_8__["InputFrame"].DESTROY_AT_CURSOR] === true) {
                            let pos = res.hitPosition.clone()
                            pos.floor()
                            landscape.chunkManager.setVoxelAtCoordinates(pos,0)
                        }
                        input.state[_input_js__WEBPACK_IMPORTED_MODULE_8__["InputFrame"].DESTROY_AT_CURSOR] = false
                    })
                })
            })
        })
    }
}
HighlightSystem.queries = {
    highlights: { components: [Highlight]},
    stagePos: { components: [_camera_gimbal_js__WEBPACK_IMPORTED_MODULE_5__["StagePosition"]]},
    stageRot: { components: [_camera_gimbal_js__WEBPACK_IMPORTED_MODULE_5__["StageRotation"]]},
    mouse: { components:[_mouse_js__WEBPACK_IMPORTED_MODULE_6__["MouseCursor"]] },
    inputs: { components:[_input_js__WEBPACK_IMPORTED_MODULE_8__["InputFrame"]]},
    camera: { components:[ecsy_three__WEBPACK_IMPORTED_MODULE_3__["Camera"]] },
    landscape: { components:[_voxels_js__WEBPACK_IMPORTED_MODULE_7__["VoxelLandscape"]]},
    active: { components:[ActiveBlock]}
}


/***/ }),

/***/ "./src/ecsy/index.js":
/*!***************************!*\
  !*** ./src/ecsy/index.js ***!
  \***************************/
/*! exports provided: MouseCursor, MouseSystem, KeyboardBindingSet, KeyboardSystem, VoxelLandscape, VoxelTextures, VoxelSystem, Highlight, ActiveBlock, HighlightSystem, StagePosition, StageRotation, WebXRActive, WebXRButton, WebXRController, WebXRSystem, FullscreenMode, FullscreenButton, FullscreenSystem, DomDashboard, DashboardVisible, DashboardDOMOvleraySystem, InputFrame, VoxelPlayerSystem */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _mouse_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./mouse.js */ "./src/ecsy/mouse.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "MouseCursor", function() { return _mouse_js__WEBPACK_IMPORTED_MODULE_0__["MouseCursor"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "MouseSystem", function() { return _mouse_js__WEBPACK_IMPORTED_MODULE_0__["MouseSystem"]; });

/* harmony import */ var _keyboard_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./keyboard.js */ "./src/ecsy/keyboard.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "KeyboardBindingSet", function() { return _keyboard_js__WEBPACK_IMPORTED_MODULE_1__["KeyboardBindingSet"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "KeyboardSystem", function() { return _keyboard_js__WEBPACK_IMPORTED_MODULE_1__["KeyboardSystem"]; });

/* harmony import */ var _voxels_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./voxels.js */ "./src/ecsy/voxels.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "VoxelLandscape", function() { return _voxels_js__WEBPACK_IMPORTED_MODULE_2__["VoxelLandscape"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "VoxelTextures", function() { return _voxels_js__WEBPACK_IMPORTED_MODULE_2__["VoxelTextures"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "VoxelSystem", function() { return _voxels_js__WEBPACK_IMPORTED_MODULE_2__["VoxelSystem"]; });

/* harmony import */ var _highlight_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./highlight.js */ "./src/ecsy/highlight.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "Highlight", function() { return _highlight_js__WEBPACK_IMPORTED_MODULE_3__["Highlight"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "ActiveBlock", function() { return _highlight_js__WEBPACK_IMPORTED_MODULE_3__["ActiveBlock"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "HighlightSystem", function() { return _highlight_js__WEBPACK_IMPORTED_MODULE_3__["HighlightSystem"]; });

/* harmony import */ var _camera_gimbal_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./camera_gimbal.js */ "./src/ecsy/camera_gimbal.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "StagePosition", function() { return _camera_gimbal_js__WEBPACK_IMPORTED_MODULE_4__["StagePosition"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "StageRotation", function() { return _camera_gimbal_js__WEBPACK_IMPORTED_MODULE_4__["StageRotation"]; });

/* harmony import */ var _webxr_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./webxr.js */ "./src/ecsy/webxr.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "WebXRActive", function() { return _webxr_js__WEBPACK_IMPORTED_MODULE_5__["WebXRActive"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "WebXRButton", function() { return _webxr_js__WEBPACK_IMPORTED_MODULE_5__["WebXRButton"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "WebXRController", function() { return _webxr_js__WEBPACK_IMPORTED_MODULE_5__["WebXRController"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "WebXRSystem", function() { return _webxr_js__WEBPACK_IMPORTED_MODULE_5__["WebXRSystem"]; });

/* harmony import */ var _fullscreen_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./fullscreen.js */ "./src/ecsy/fullscreen.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "FullscreenMode", function() { return _fullscreen_js__WEBPACK_IMPORTED_MODULE_6__["FullscreenMode"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "FullscreenButton", function() { return _fullscreen_js__WEBPACK_IMPORTED_MODULE_6__["FullscreenButton"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "FullscreenSystem", function() { return _fullscreen_js__WEBPACK_IMPORTED_MODULE_6__["FullscreenSystem"]; });

/* harmony import */ var _dashboard_js__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./dashboard.js */ "./src/ecsy/dashboard.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "DomDashboard", function() { return _dashboard_js__WEBPACK_IMPORTED_MODULE_7__["DomDashboard"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "DashboardVisible", function() { return _dashboard_js__WEBPACK_IMPORTED_MODULE_7__["DashboardVisible"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "DashboardDOMOvleraySystem", function() { return _dashboard_js__WEBPACK_IMPORTED_MODULE_7__["DashboardDOMOvleraySystem"]; });

/* harmony import */ var _input_js__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./input.js */ "./src/ecsy/input.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "InputFrame", function() { return _input_js__WEBPACK_IMPORTED_MODULE_8__["InputFrame"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "VoxelPlayerSystem", function() { return _input_js__WEBPACK_IMPORTED_MODULE_8__["VoxelPlayerSystem"]; });












/***/ }),

/***/ "./src/ecsy/input.js":
/*!***************************!*\
  !*** ./src/ecsy/input.js ***!
  \***************************/
/*! exports provided: InputFrame, VoxelPlayerSystem */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InputFrame", function() { return InputFrame; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "VoxelPlayerSystem", function() { return VoxelPlayerSystem; });
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ecsy */ "ecsy");
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(ecsy__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _camera_gimbal_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./camera_gimbal.js */ "./src/ecsy/camera_gimbal.js");
/* harmony import */ var ecsy_three__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ecsy-three */ "ecsy-three");
/* harmony import */ var ecsy_three__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(ecsy_three__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_3__);





class InputFrame extends ecsy__WEBPACK_IMPORTED_MODULE_0__["Component"] {
    constructor() {
        super();
        this.state = {
            ROTATE_LEFT:false,
            ROTATE_RIGHT:false,
            LEFT_STRAFE:false,
            RIGHT_STRAFE:false,
            MOVE_FORWARD:false,
            MOVE_BACKWARD:false,
        }
    }
}
InputFrame.LEFT_STRAFE = 'LEFT_STRAFE'
InputFrame.RIGHT_STRAFE = 'RIGHT_STRAFE'
InputFrame.MOVE_FORWARD = 'MOVE_FORWARD'
InputFrame.MOVE_BACKWARD = 'MOVE_BACKWARD'
InputFrame.ROTATE_LEFT = 'ROTATE_LEFT'
InputFrame.ROTATE_RIGHT = 'ROTATE_RIGHT'
InputFrame.OPEN_DASHBOARD = 'OPEN_DASHBOARD'
InputFrame.ROTATION_DRAGGING = 'ROTATION_DRAGGING'
InputFrame.ROTATION_ANGLE = 'ROTATION_ANGLE'
InputFrame.CREATE_AT_CURSOR = 'CREATE_AT_CURSOR'
InputFrame.DESTROY_AT_CURSOR = 'DESTROY_AT_CURSOR'

const Y_AXIS = new three__WEBPACK_IMPORTED_MODULE_3__["Vector3"](0,1,0)
const SPEED = 0.1

class VoxelPlayerSystem extends ecsy__WEBPACK_IMPORTED_MODULE_0__["System"] {
    init() {
        console.log("voxel system initting")
    }
    execute(delta, time) {
        this.queries.inputs.results.forEach(ent => {
            let input = ent.getComponent(InputFrame)
            this.queries.stageRot.results.forEach(ent => {
                let rot_trans = ent.getMutableComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Transform"])
                if (input.state[InputFrame.ROTATE_LEFT] === true) {
                    rot_trans.rotation.y -= 0.05
                }
                if (input.state[InputFrame.ROTATE_RIGHT] === true) {
                    rot_trans.rotation.y += 0.05
                }
                if (input.state[InputFrame.ROTATION_DRAGGING] === true) {
                    rot_trans.rotation.y = input.state[InputFrame.ROTATION_ANGLE]
                } else {
                    input.state[InputFrame.ROTATION_ANGLE] = rot_trans.rotation.y
                }
            })

            this.queries.stagePos.results.forEach(ent => {
                if(input.state[InputFrame.MOVE_FORWARD] === true) {
                    let stageRot = ent.getComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Parent"]).value
                    let pos_trans = ent.getMutableComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Transform"])
                    const dir = new three__WEBPACK_IMPORTED_MODULE_3__["Vector3"](0,0,1)
                    dir.applyAxisAngle(Y_AXIS, -stageRot.getComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Transform"]).rotation.y)
                    let d2 = dir.normalize().multiplyScalar(SPEED)
                    const vel = d2.multiplyScalar(4)
                    pos_trans.position.x += vel.x;
                    pos_trans.position.z += vel.z;
                }
                if(input.state[InputFrame.MOVE_BACKWARD] === true) {
                    let stageRot = ent.getComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Parent"]).value
                    let pos_trans = ent.getMutableComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Transform"])
                    const dir = new three__WEBPACK_IMPORTED_MODULE_3__["Vector3"](0,0,1)
                    dir.applyAxisAngle(Y_AXIS, -stageRot.getComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Transform"]).rotation.y)
                    let d2 = dir.normalize().multiplyScalar(SPEED)
                    const vel = d2.multiplyScalar(-4)
                    pos_trans.position.x += vel.x;
                    pos_trans.position.z += vel.z;
                }
                if(input.state[InputFrame.LEFT_STRAFE] === true) {
                    let stageRot = ent.getComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Parent"]).value
                    let pos_trans = ent.getMutableComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Transform"])
                    const dir = new three__WEBPACK_IMPORTED_MODULE_3__["Vector3"](0,0,1)
                    dir.applyAxisAngle(Y_AXIS, -stageRot.getComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Transform"]).rotation.y + Math.PI/2)
                    let d2 = dir.normalize().multiplyScalar(SPEED)
                    const vel = d2.multiplyScalar(4)
                    pos_trans.position.x += vel.x;
                    pos_trans.position.z += vel.z;
                }
                if(input.state[InputFrame.RIGHT_STRAFE] === true) {
                    let stageRot = ent.getComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Parent"]).value
                    let pos_trans = ent.getMutableComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Transform"])
                    const dir = new three__WEBPACK_IMPORTED_MODULE_3__["Vector3"](0,0,1)
                    dir.applyAxisAngle(Y_AXIS, -stageRot.getComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Transform"]).rotation.y - Math.PI/2)
                    let d2 = dir.normalize().multiplyScalar(SPEED)
                    const vel = d2.multiplyScalar(4)
                    pos_trans.position.x += vel.x;
                    pos_trans.position.z += vel.z;
                }
            })
        })
    }
}

VoxelPlayerSystem.queries = {
    inputs: {
        components: [InputFrame],
    },
    stageRot: {
        components: [_camera_gimbal_js__WEBPACK_IMPORTED_MODULE_1__["StageRotation"], ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Transform"]],
    },
    stagePos: {
        components: [_camera_gimbal_js__WEBPACK_IMPORTED_MODULE_1__["StagePosition"], ecsy_three__WEBPACK_IMPORTED_MODULE_2__["Transform"]],
    }
}


/***/ }),

/***/ "./src/ecsy/keyboard.js":
/*!******************************!*\
  !*** ./src/ecsy/keyboard.js ***!
  \******************************/
/*! exports provided: KeyboardBindingSet, KeyboardSystem */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "KeyboardBindingSet", function() { return KeyboardBindingSet; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "KeyboardSystem", function() { return KeyboardSystem; });
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ecsy */ "ecsy");
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(ecsy__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _input_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./input.js */ "./src/ecsy/input.js");



class KeyboardBindingSet extends ecsy__WEBPACK_IMPORTED_MODULE_0__["Component"] {
    constructor() {
        super();
        this.bindings = {}
    }
}

class KeyboardSystem extends ecsy__WEBPACK_IMPORTED_MODULE_0__["System"] {
    _setBindingValue(keyboard_key, new_value) {
        this.queries.bindings.results.forEach(ent => {
            let binding = ent.getComponent(KeyboardBindingSet)
            if(binding.bindings[keyboard_key]) {
                let state_key = binding.bindings[keyboard_key]
                this.queries.inputs.results.forEach(ent => {
                    let input = ent.getMutableComponent(_input_js__WEBPACK_IMPORTED_MODULE_1__["InputFrame"])
                    input.state[state_key] = new_value
                })
            }
        })
    }

    _keydown(e) {
        this._setBindingValue(e.key,true);
    }
    _keyup(e) {
        this._setBindingValue(e.key,false);
    }
    init() {
        document.addEventListener('keydown',this._keydown.bind(this));
        document.addEventListener('keyup',this._keyup.bind(this));
    }
}
KeyboardSystem.queries = {
    bindings: {
        components:[KeyboardBindingSet]
    },
    inputs: {
        components: [_input_js__WEBPACK_IMPORTED_MODULE_1__["InputFrame"]],
    }
}


/***/ }),

/***/ "./src/ecsy/mouse.js":
/*!***************************!*\
  !*** ./src/ecsy/mouse.js ***!
  \***************************/
/*! exports provided: MouseCursor, MouseSystem */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MouseCursor", function() { return MouseCursor; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MouseSystem", function() { return MouseSystem; });
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ecsy */ "ecsy");
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(ecsy__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _input_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./input.js */ "./src/ecsy/input.js");




class MouseCursor extends ecsy__WEBPACK_IMPORTED_MODULE_0__["Component"] {
    constructor() {
        super();
        this.position = new three__WEBPACK_IMPORTED_MODULE_1__["Vector2"]()
        this.buttons = 0
        this.down = false
    }
}
class MouseSystem extends ecsy__WEBPACK_IMPORTED_MODULE_0__["System"] {
    _mouse_down(e) {
        this.pressed = true
        this.buttons = e.buttons
        this.start_point = this.last_point.clone()
        this.queries.inputs.results.forEach(ent => {
            let input = ent.getMutableComponent(_input_js__WEBPACK_IMPORTED_MODULE_2__["InputFrame"])
            input.state[_input_js__WEBPACK_IMPORTED_MODULE_2__["InputFrame"].ROTATION_DRAGGING] = true
            this.start_angle = input.state[_input_js__WEBPACK_IMPORTED_MODULE_2__["InputFrame"].ROTATION_ANGLE]
        })

    }
    _mouse_move(e) {
        this.last_point = new three__WEBPACK_IMPORTED_MODULE_1__["Vector2"](e.clientX,e.clientY)
        if(this.pressed) {
            let diff = this.last_point.clone().sub(this.start_point)
            let new_angle = this.start_angle - 0.003*diff.x
            this.queries.inputs.results.forEach(ent => {
                let input = ent.getMutableComponent(_input_js__WEBPACK_IMPORTED_MODULE_2__["InputFrame"])
                input.state[_input_js__WEBPACK_IMPORTED_MODULE_2__["InputFrame"].ROTATION_ANGLE] = new_angle
            })
        }
    }
    _mouse_up(e) {
        this.pressed = false
        let diff = this.last_point.clone().sub(this.start_point)
        this.queries.inputs.results.forEach(ent => {
            let input = ent.getMutableComponent(_input_js__WEBPACK_IMPORTED_MODULE_2__["InputFrame"])
            input.state[_input_js__WEBPACK_IMPORTED_MODULE_2__["InputFrame"].ROTATION_DRAGGING] = false
            if(Math.abs(diff.x) < 10) {
                if(this.buttons === 1) {
                    input.state[_input_js__WEBPACK_IMPORTED_MODULE_2__["InputFrame"].CREATE_AT_CURSOR] = true
                }
                if(this.buttons === 2) {
                    input.state[_input_js__WEBPACK_IMPORTED_MODULE_2__["InputFrame"].DESTROY_AT_CURSOR] = true
                }

            }
        })
    }
    init() {
        this.last_point = new three__WEBPACK_IMPORTED_MODULE_1__["Vector2"](200,200)
        document.addEventListener('contextmenu',e => {
            e.preventDefault()
            e.stopPropagation()
        })
        document.addEventListener('mousemove',(e)=>this._mouse_move(e))
        document.addEventListener('mousedown', (e)=>this._mouse_down(e))
        document.addEventListener('mouseup', (e)=>this._mouse_up(e))
    }
    execute(delta,time) {
        this.queries.targets.results.forEach(ent => {
            ent.getMutableComponent(MouseCursor).position.copy(this.last_point)
        })
    }
}
MouseSystem.queries = {
    targets: {
        components: [MouseCursor]
    },
    inputs: {
        components: [_input_js__WEBPACK_IMPORTED_MODULE_2__["InputFrame"]],
    }
}


/***/ }),

/***/ "./src/ecsy/voxels.js":
/*!****************************!*\
  !*** ./src/ecsy/voxels.js ***!
  \****************************/
/*! exports provided: VoxelLandscape, VoxelTextures, VoxelSystem */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "VoxelLandscape", function() { return VoxelLandscape; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "VoxelTextures", function() { return VoxelTextures; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "VoxelSystem", function() { return VoxelSystem; });
/* harmony import */ var _TextureManager_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../TextureManager.js */ "./src/TextureManager.js");
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ecsy */ "ecsy");
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(ecsy__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _ChunkManager_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../ChunkManager.js */ "./src/ChunkManager.js");
/* harmony import */ var _CulledMesher_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../CulledMesher.js */ "./src/CulledMesher.js");
/* harmony import */ var _utils_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../utils.js */ "./src/utils.js");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var ecsy_three__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ecsy-three */ "ecsy-three");
/* harmony import */ var ecsy_three__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(ecsy_three__WEBPACK_IMPORTED_MODULE_6__);








class VoxelLandscape extends ecsy__WEBPACK_IMPORTED_MODULE_1__["Component"] {
    constructor() {
        super()
        this.chunkManager = null
        this.make_voxel = null
    }
}
class VoxelTextures extends ecsy__WEBPACK_IMPORTED_MODULE_1__["Component"] {
    constructor() {
        super();
        this.tm = null
        this.textures = []
    }
}
class VoxelSystem extends ecsy__WEBPACK_IMPORTED_MODULE_1__["System"] {
    execute(delta, time) {
        this.queries.entities.added.forEach(entity => {
            let land = entity.getMutableComponent(VoxelLandscape)
            //setup the chunk manager
            land.chunkManager = new _ChunkManager_js__WEBPACK_IMPORTED_MODULE_2__["ChunkManager"]({
                chunkDistance:1,
                blockSize:1,
                mesher: new _CulledMesher_js__WEBPACK_IMPORTED_MODULE_3__["CulledMesher"](),
                chunkSize:16,
                generateVoxelChunk: (low, high, pos) => {
                    const id = [pos.x,pos.y,pos.z].join('|')
                    return Object(_utils_js__WEBPACK_IMPORTED_MODULE_4__["generateChunkInfoFromFunction"])(low, high, land.make_voxel)
                },
                container: new three__WEBPACK_IMPORTED_MODULE_5__["Group"](),
                textureManager: new _TextureManager_js__WEBPACK_IMPORTED_MODULE_0__["TextureManager"]({aoEnabled:true}),
            });
            let texs = entity.getMutableComponent(VoxelTextures)
            texs.tm = land.chunkManager.textureManager
            texs.tm.loadTextures(texs.textures).then(()=>{
                console.log("textures are loaded")
                land.chunkManager.rebuildAllMeshes()
                land.chunkManager.requestMissingChunks(new three__WEBPACK_IMPORTED_MODULE_5__["Vector3"](0,0,0))
            })
            entity.addComponent(ecsy_three__WEBPACK_IMPORTED_MODULE_6__["Object3D"], {value: land.chunkManager.container})
        })
    }
}
VoxelSystem.queries = {
    entities: {
        components: [VoxelLandscape, VoxelTextures],
        listen: {
            added: true,
            removed: true
        }
    }
}


/***/ }),

/***/ "./src/ecsy/webxr.js":
/*!***************************!*\
  !*** ./src/ecsy/webxr.js ***!
  \***************************/
/*! exports provided: WebXRActive, WebXRButton, WebXRController, WebXRSystem */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "WebXRActive", function() { return WebXRActive; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "WebXRButton", function() { return WebXRButton; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "WebXRController", function() { return WebXRController; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "WebXRSystem", function() { return WebXRSystem; });
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ecsy */ "ecsy");
/* harmony import */ var ecsy__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(ecsy__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _fullscreen_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./fullscreen.js */ "./src/ecsy/fullscreen.js");



class WebXRActive extends ecsy__WEBPACK_IMPORTED_MODULE_0__["Component"] {
}

class WebXRButton extends ecsy__WEBPACK_IMPORTED_MODULE_0__["Component"] {
    constructor() {
        super();
        this.currentSession = null
    }
}

class WebXRController extends ecsy__WEBPACK_IMPORTED_MODULE_0__["Component"] {
    constructor() {
        super()
        this.controller = null
        this.index = -1
        this.selected = false
    }
}
class WebXRSystem extends ecsy__WEBPACK_IMPORTED_MODULE_0__["System"] {
    enterWebXR(ent) {
        console.log('trying to enter webxr')
        let state = ent.getMutableComponent(WebXRButton);
        if(state.currentSession === null) {
            navigator.xr.requestSession('immersive-vr').then(session=>{
                console.log("session has started")
                let onSessionEnded = () => {
                    console.log("session ended")
                    state.currentSession.removeEventListener('end',onSessionEnded)
                    renderer.vr.setSession(null)
                    ent.removeComponent(WebXRActive)
                }
                session.addEventListener('end',onSessionEnded)
                renderer.vr.setSession(session)
                state.currentSession = session
                ent.addComponent(WebXRActive)
            })
        } else {
            state.currentSession.end()
        }
    }
    execute(delta, time) {
        this.queries.buttons.added.forEach(ent => {
            console.log("button added");
            let elem = document.createElement('button')
            elem.innerText = "webxr"
            elem.classList.add("webxr")
            elem.addEventListener('click', (e) => {
                e.stopPropagation()
                e.preventDefault()
                this.enterWebXR(ent);
            })
            elem.disabled = true
            document.documentElement.append(elem)
            console.log("added the element", elem)

            if ( 'xr' in navigator && 'supportsSession' in navigator.xr ) {
                navigator.xr.supportsSession( 'immersive-vr' ).then(()=>{
                    console.log("immersive is supported");
                    elem.disabled = false
                }).catch((e)=>{
                    console.error(e)
                });
            } else {
                console.log("does not have webxr");
            }
        })
        this.queries.controllers.added.forEach(ent => {
            const con = ent.getMutableComponent(WebXRController)
            // const domElement = document.querySelector("canvas")

            con.controller = renderer.xr.getController(con.index)
            con.controller.addEventListener('selectstart', (evt)=>{
                console.log("controller select start")
                con.selected = true
            });
            con.controller.addEventListener('selectend', (evt)=>{
                console.log("controller select end")
                con.selected = false
            });
        })
    }
}
WebXRSystem.queries = {
    buttons: {
        components: [ WebXRButton],
        listen: {
            added:true,
        }
    },
    active: {
        components: [WebXRActive],
        listen: {
            added:true,
            removed:false,
        }
    },
    controllers: {
        components: [WebXRController],
        listen: {
            added: true,
            removed: true
        }
    },
}






/***/ }),

/***/ "./src/index.js":
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
/*! exports provided: ChunkManager, CulledMesher, DesktopControls, ECSComp, FullScreenControls, GreedyMesher, KeyboardControls, PhysHandler, Physical, traceRay, checkHitTileY, checkHitTileX, checkHitTileZ, SimpleMeshCollider, TextureManager, TouchControls, toHexColor, generateChunkInfoFromFunction, toRad, EPSILON, $, DIRS, on, traceRayAtScreenCoords, rand, VoxelMesh, VoxelTexture, VRControls, MouseCursor, MouseSystem, KeyboardBindingSet, KeyboardSystem, VoxelLandscape, VoxelTextures, VoxelSystem, Highlight, ActiveBlock, HighlightSystem, StagePosition, StageRotation, WebXRActive, WebXRButton, WebXRController, WebXRSystem, FullscreenMode, FullscreenButton, FullscreenSystem, DomDashboard, DashboardVisible, DashboardDOMOvleraySystem, InputFrame, VoxelPlayerSystem */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _ChunkManager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./ChunkManager */ "./src/ChunkManager.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "ChunkManager", function() { return _ChunkManager__WEBPACK_IMPORTED_MODULE_0__["ChunkManager"]; });

/* harmony import */ var _CulledMesher__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./CulledMesher */ "./src/CulledMesher.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "CulledMesher", function() { return _CulledMesher__WEBPACK_IMPORTED_MODULE_1__["CulledMesher"]; });

/* harmony import */ var _DesktopControls__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./DesktopControls */ "./src/DesktopControls.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "DesktopControls", function() { return _DesktopControls__WEBPACK_IMPORTED_MODULE_2__["DesktopControls"]; });

/* harmony import */ var _ECSComp__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./ECSComp */ "./src/ECSComp.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "ECSComp", function() { return _ECSComp__WEBPACK_IMPORTED_MODULE_3__["ECSComp"]; });

/* harmony import */ var _FullscreenControls__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./FullscreenControls */ "./src/FullscreenControls.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "FullScreenControls", function() { return _FullscreenControls__WEBPACK_IMPORTED_MODULE_4__["FullScreenControls"]; });

/* harmony import */ var _GreedyMesher__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./GreedyMesher */ "./src/GreedyMesher.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "GreedyMesher", function() { return _GreedyMesher__WEBPACK_IMPORTED_MODULE_5__["GreedyMesher"]; });

/* harmony import */ var _KeyboardControls__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./KeyboardControls */ "./src/KeyboardControls.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "KeyboardControls", function() { return _KeyboardControls__WEBPACK_IMPORTED_MODULE_6__["KeyboardControls"]; });

/* harmony import */ var _PhysHandler__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./PhysHandler */ "./src/PhysHandler.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "PhysHandler", function() { return _PhysHandler__WEBPACK_IMPORTED_MODULE_7__["PhysHandler"]; });

/* harmony import */ var _physical__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./physical */ "./src/physical.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "Physical", function() { return _physical__WEBPACK_IMPORTED_MODULE_8__["Physical"]; });

/* harmony import */ var _raycast__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./raycast */ "./src/raycast.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "traceRay", function() { return _raycast__WEBPACK_IMPORTED_MODULE_9__["traceRay"]; });

/* harmony import */ var _SimpleMeshCollider__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./SimpleMeshCollider */ "./src/SimpleMeshCollider.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "checkHitTileY", function() { return _SimpleMeshCollider__WEBPACK_IMPORTED_MODULE_10__["checkHitTileY"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "checkHitTileX", function() { return _SimpleMeshCollider__WEBPACK_IMPORTED_MODULE_10__["checkHitTileX"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "checkHitTileZ", function() { return _SimpleMeshCollider__WEBPACK_IMPORTED_MODULE_10__["checkHitTileZ"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "SimpleMeshCollider", function() { return _SimpleMeshCollider__WEBPACK_IMPORTED_MODULE_10__["SimpleMeshCollider"]; });

/* harmony import */ var _TextureManager__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./TextureManager */ "./src/TextureManager.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "TextureManager", function() { return _TextureManager__WEBPACK_IMPORTED_MODULE_11__["TextureManager"]; });

/* harmony import */ var _TouchControls__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./TouchControls */ "./src/TouchControls.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "TouchControls", function() { return _TouchControls__WEBPACK_IMPORTED_MODULE_12__["TouchControls"]; });

/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./utils */ "./src/utils.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "toHexColor", function() { return _utils__WEBPACK_IMPORTED_MODULE_13__["toHexColor"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "generateChunkInfoFromFunction", function() { return _utils__WEBPACK_IMPORTED_MODULE_13__["generateChunkInfoFromFunction"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "toRad", function() { return _utils__WEBPACK_IMPORTED_MODULE_13__["toRad"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "EPSILON", function() { return _utils__WEBPACK_IMPORTED_MODULE_13__["EPSILON"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "$", function() { return _utils__WEBPACK_IMPORTED_MODULE_13__["$"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "DIRS", function() { return _utils__WEBPACK_IMPORTED_MODULE_13__["DIRS"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "on", function() { return _utils__WEBPACK_IMPORTED_MODULE_13__["on"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "traceRayAtScreenCoords", function() { return _utils__WEBPACK_IMPORTED_MODULE_13__["traceRayAtScreenCoords"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "rand", function() { return _utils__WEBPACK_IMPORTED_MODULE_13__["rand"]; });

/* harmony import */ var _VoxelMesh__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./VoxelMesh */ "./src/VoxelMesh.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "VoxelMesh", function() { return _VoxelMesh__WEBPACK_IMPORTED_MODULE_14__["VoxelMesh"]; });

/* harmony import */ var _VoxelTexture__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./VoxelTexture */ "./src/VoxelTexture.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "VoxelTexture", function() { return _VoxelTexture__WEBPACK_IMPORTED_MODULE_15__["VoxelTexture"]; });

/* harmony import */ var _VRControls__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./VRControls */ "./src/VRControls.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "VRControls", function() { return _VRControls__WEBPACK_IMPORTED_MODULE_16__["VRControls"]; });

/* harmony import */ var _VRStats__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./VRStats */ "./src/VRStats.js");
/* empty/unused harmony star reexport *//* harmony import */ var _ecsy__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ./ecsy */ "./src/ecsy/index.js");
/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "MouseCursor", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["MouseCursor"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "MouseSystem", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["MouseSystem"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "KeyboardBindingSet", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["KeyboardBindingSet"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "KeyboardSystem", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["KeyboardSystem"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "VoxelLandscape", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["VoxelLandscape"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "VoxelTextures", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["VoxelTextures"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "VoxelSystem", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["VoxelSystem"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "Highlight", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["Highlight"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "ActiveBlock", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["ActiveBlock"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "HighlightSystem", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["HighlightSystem"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "StagePosition", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["StagePosition"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "StageRotation", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["StageRotation"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "WebXRActive", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["WebXRActive"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "WebXRButton", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["WebXRButton"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "WebXRController", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["WebXRController"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "WebXRSystem", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["WebXRSystem"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "FullscreenMode", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["FullscreenMode"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "FullscreenButton", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["FullscreenButton"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "FullscreenSystem", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["FullscreenSystem"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "DomDashboard", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["DomDashboard"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "DashboardVisible", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["DashboardVisible"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "DashboardDOMOvleraySystem", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["DashboardDOMOvleraySystem"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "InputFrame", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["InputFrame"]; });

/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, "VoxelPlayerSystem", function() { return _ecsy__WEBPACK_IMPORTED_MODULE_18__["VoxelPlayerSystem"]; });

//export * from './ecsy';





















/***/ }),

/***/ "./src/physical.js":
/*!*************************!*\
  !*** ./src/physical.js ***!
  \*************************/
/*! exports provided: Physical */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Physical", function() { return Physical; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);
// module.exports = physical
//import {AABB as aabb} from "./aabb.js"


// make these *once*, so we're not generating
// garbage for every object in the game.
const WORLD_DESIRED = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0, 0, 0)
    , DESIRED = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0, 0, 0)
    , START = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0, 0, 0)
    , END = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0, 0, 0)
    , DIRECTION = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"]()
    , LOCAL_ATTRACTOR = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"]()
    , TOTAL_FORCES = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"]()

function applyTo(which) {
    return function(world) {
        var local = this.avatar.worldToLocal(world)
        this[which].x += local.x
        this[which].y += local.y
        this[which].z += local.z
    }
}

const abs = Math.abs

//JOSH: I don't know what this is for
// , axes = ['x', 'y', 'z']

class Physical {

    constructor(avatar, collidables, dimensions, terminal) {
        //a connection to the underlying threejs object
        this.avatar = avatar
        //terminal velocity. default is pretty slow?
        this.terminal = terminal || new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0.9, 0.1, 0.9)
        //the size of the object as width, height, depth in a vector3
        //default dimensions are a 1x1x1 cube
        this.dimensions = dimensions = dimensions || new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](1, 1, 1)
        //turn dimensions into an AABB (axis aligned bounding box)
        this._aabb = aabb(new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0, 0, 0), dimensions)
        //indicates if not moving in each direction
        this.resting = {x: false, y: false, z: false}
        this.old_resting_y = 0
        this.last_rest_y = NaN

        //a list of objects that this Physical can collide with
        this.collidables = collidables
        //default fiction. should this be modifyable?
        this.friction = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](1, 1, 1)

        //the current rotation of the avatar. a threejs euler angle
        this.rotation = this.avatar.rotation
        this.default_friction = 1

        // default yaw/pitch/roll controls to the avatar
        this.yaw =
            this.pitch =
                this.roll = avatar

        // the current total of forces affecting this object
        this.forces = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0, 0, 0)
        // a list of attractors affecting this object. meaning something you are pulled towards
        this.attractors = []
        //current acceleration.
        this.acceleration = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0, 0, 0)
        //current velocity
        this.velocity = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0, 0, 0)


        this.applyWorldAcceleration = applyTo('acceleration')
        this.applyWorldVelocity = applyTo('velocity')
    }


    tick(dt) {
        let forces = this.forces
        let acceleration = this.acceleration
        let velocity = this.velocity
        let terminal = this.terminal
        let friction = this.friction
        let desired = DESIRED
        let world_desired = WORLD_DESIRED
        let bbox
        let pcs

        TOTAL_FORCES.multiplyScalar(0)

        desired.x =
            desired.y =
                desired.z =
                    world_desired.x =
                        world_desired.y =
                            world_desired.z = 0

        //add in the attractors force
        /*
        for (let i = 0; i < this.attractors.length; i++) {
            var distance_factor = this.avatar.position.distanceToSquared(this.attractors[i])
            LOCAL_ATTRACTOR.copy(this.attractors[i])
            LOCAL_ATTRACTOR = this.avatar.worldToLocal(LOCAL_ATTRACTOR)

            DIRECTION.sub(LOCAL_ATTRACTOR, this.avatar.position)

            DIRECTION.divideScalar(DIRECTION.length() * distance_factor)
            DIRECTION.multiplyScalar(this.attractors[i].mass)

            TOTAL_FORCES.addSelf(DIRECTION)
        }
        */

        dt = dt/1000
        // console.log('the forces',this.forces)
        // console.log("dt",dt)
        // apply the forces
        if (!this.resting.x) {
            acceleration.x /= 8 * dt
            // acceleration.x += TOTAL_FORCES.x * dt
            acceleration.x += forces.x * dt

            velocity.x += acceleration.x * dt
            velocity.x *= friction.x

            if (abs(velocity.x) < terminal.x) {
                desired.x = (velocity.x * dt)
            } else if (velocity.x !== 0) {
                desired.x = (velocity.x / abs(velocity.x)) * terminal.x
            }
        } else {
            acceleration.x = velocity.x = 0
        }
        if (!this.resting.y) {
            // console.log('starting acc',acceleration.y)
            // acceleration.y /= 8 * dt
            acceleration.y = 0;
            // console.log("now",acceleration.y)
            // acceleration.y += TOTAL_FORCES.y * dt
            acceleration.y += forces.y * dt
            // console.log("ending accel",acceleration.y)
            // console.log('starting vel',velocity.y)
            velocity.y += acceleration.y// * dt
            // velocity.y *= friction.y
            console.log("ending vel",velocity.y)

            // console.log('desired y', desired.y)
            console.log('ternimal',terminal.y)
            if (abs(velocity.y) < terminal.y) {
                // console.log('less than terminal',)
                desired.y = (velocity.y * dt)
                // console.log('dt is',dt)
            } else if (velocity.y !== 0) {
                desired.y = (velocity.y / abs(velocity.y)) * terminal.y
            }
        } else {
            // console.log("resting again")
            acceleration.y = velocity.y = 0
        }
        if (!this.resting.z) {
            acceleration.z /= 8 * dt
            acceleration.z += TOTAL_FORCES.z * dt
            acceleration.z += forces.z * dt

            velocity.z += acceleration.z * dt
            velocity.z *= friction.z

            if (abs(velocity.z) < terminal.z) {
                desired.z = (velocity.z * dt)
            } else if (velocity.z !== 0) {
                desired.z = (velocity.z / abs(velocity.z)) * terminal.z
            }
        } else {
            acceleration.z = velocity.z = 0
        }

        // console.log('starting postion',this.avatar.position)
        // console.log('desired is',desired)
        START.copy(this.avatar.position)
        this.avatar.translateX(desired.x)
        this.avatar.translateY(desired.y)
        this.avatar.translateZ(desired.z)
        END.copy(this.avatar.position)
        this.avatar.position.copy(START)

        //START is where the object is now
        //END is where the object will be after the movement is applied
        //desired is the direction vector that was calculated
        //JOSH: I think world desired is a direction vector for the current motion
        world_desired.x = END.x - START.x
        world_desired.y = END.y - START.y
        world_desired.z = END.z - START.z
        // console.log('world destired stare is',world_desired)

        // console.log('start',START,'end',END, 'diff', world_desired)
        // console.log("world desired",world_desired)
        //set the friction in all directions
        this.friction.x =
            this.friction.y =
                this.friction.z = this.default_friction

        // save old copies, since when normally on the
        // ground, this.resting.y alternates (false,-1)
        // JOSH: this part confuses me
        this.old_resting_y = (this.old_resting_y << 1) >>> 0
        this.old_resting_y |= !!this.resting.y | 0

        // run collisions
        this.resting.x =
            this.resting.y =
                this.resting.z = false

        bbox = this.aabb()
        pcs = this.collidables

        //collide against everything except myself
        for (let i = 0, len = pcs.length; i < len; ++i) {
            if (pcs[i] !== this) {
                pcs[i].collide(this, bbox, world_desired, this.resting)
            }
        }

        //what does this part do?
        /*
        // fall distance
        if (!!(this.old_resting_y & 0x4) !== !!this.resting.y) {
            if (!this.resting.y) {
                this.last_rest_y = this.avatar.position.y
            } else if (!isNaN(this.last_rest_y)) {
                this.fell(this.last_rest_y - this.avatar.position.y)
                this.last_rest_y = NaN
            }
        }
        */

        // apply translation
        this.avatar.position.x += world_desired.x
        this.avatar.position.y += world_desired.y
        this.avatar.position.z += world_desired.z
    }


    subjectTo (force) {
        this.forces.x += force[0]
        this.forces.y += force[1]
        this.forces.z += force[2]
        return this
    }



    removeForce (force) {
        this.forces.x -= force[0]
        this.forces.y -= force[1]
        this.forces.z -= force[2]
        return this
    }



    attractTo (vector, mass) {
        vector.mass = mass
        this.attractors.push(vector)
    }



    aabb () {
        const pos = this.avatar.position
        const d = this.dimensions
        return aabb(
            new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](pos.x - (d.x / 2), pos.y, pos.z - (d.z / 2)),
            this.dimensions
        )
    }

// no object -> object collisions for now, thanks


    collide (other, bbox, world_vec, resting) {
        return
    }



    atRestX () {
        return this.resting.x
    }



    atRestY () {
        return this.resting.y
    }

    atRestZ () {
        return this.resting.z
    }

    fell (distance) {
        return
    }
}


/***/ }),

/***/ "./src/raycast.js":
/*!************************!*\
  !*** ./src/raycast.js ***!
  \************************/
/*! exports provided: traceRay */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "traceRay", function() { return traceRay; });
function traceRay_impl(
    voxelProvider,
    px, py, pz,
    dx, dy, dz,
    max_d,
    hit_pos,
    hit_norm,
    EPSILON) {
    var t = 0.0
        , nx=0, ny=0, nz=0
        , ix, iy, iz
        , fx, fy, fz
        , ox, oy, oz
        , ex, ey, ez
        , b, step, min_step
        , floor = Math.floor
    //Step block-by-block along ray
    while(t <= max_d) {
        ox = px + t * dx
        oy = py + t * dy
        oz = pz + t * dz
        ix = floor(ox)|0
        iy = floor(oy)|0
        iz = floor(oz)|0
        fx = ox - ix
        fy = oy - iy
        fz = oz - iz
        b = voxelProvider.getBlock(ix, iy, iz)
        if(b) {
            if(hit_pos) {
                //Clamp to face on hit
                hit_pos.x = fx < EPSILON ? +ix : (fx > 1.0-EPSILON ? ix+1.0-EPSILON : ox)
                hit_pos.y = fy < EPSILON ? +iy : (fy > 1.0-EPSILON ? iy+1.0-EPSILON : oy)
                hit_pos.z = fz < EPSILON ? +iz : (fz > 1.0-EPSILON ? iz+1.0-EPSILON : oz)
            }
            if(hit_norm) {
                hit_norm.x = nx
                hit_norm.y = ny
                hit_norm.z = nz
            }
            return b
        }
        //Check edge cases
        min_step = +(EPSILON * (1.0 + t))
        if(t > min_step) {
            ex = nx < 0 ? fx <= min_step : fx >= 1.0 - min_step
            ey = ny < 0 ? fy <= min_step : fy >= 1.0 - min_step
            ez = nz < 0 ? fz <= min_step : fz >= 1.0 - min_step
            if(ex && ey && ez) {
                b = voxelProvider.getBlock(ix+nx, iy+ny, iz) ||
                    voxelProvider.getBlock(ix, iy+ny, iz+nz) ||
                    voxelProvider.getBlock(ix+nx, iy, iz+nz)
                if(b) {
                    if(hit_pos) {
                        hit_pos.x = nx < 0 ? ix-EPSILON : ix + 1.0-EPSILON
                        hit_pos.y = ny < 0 ? iy-EPSILON : iy + 1.0-EPSILON
                        hit_pos.z = nz < 0 ? iz-EPSILON : iz + 1.0-EPSILON
                    }
                    if(hit_norm) {
                        hit_norm.x = nx
                        hit_norm.y = ny
                        hit_norm.z = nz
                    }
                    return b
                }
            }
            if(ex && (ey || ez)) {
                b = voxelProvider.getBlock(ix+nx, iy, iz)
                if(b) {
                    if(hit_pos) {
                        hit_pos.x = nx < 0 ? ix-EPSILON : ix + 1.0-EPSILON
                        hit_pos.y = fy < EPSILON ? +iy : oy
                        hit_pos.z = fz < EPSILON ? +iz : oz
                    }
                    if(hit_norm) {
                        hit_norm.x = nx
                        hit_norm.y = ny
                        hit_norm.z = nz
                    }
                    return b
                }
            }
            if(ey && (ex || ez)) {
                b = voxelProvider.getBlock(ix, iy+ny, iz)
                if(b) {
                    if(hit_pos) {
                        hit_pos.x = fx < EPSILON ? +ix : ox
                        hit_pos.y = ny < 0 ? iy-EPSILON : iy + 1.0-EPSILON
                        hit_pos.z = fz < EPSILON ? +iz : oz
                    }
                    if(hit_norm) {
                        hit_norm.x = nx
                        hit_norm.y = ny
                        hit_norm.z = nz
                    }
                    return b
                }
            }
            if(ez && (ex || ey)) {
                b = voxelProvider.getBlock(ix, iy, iz+nz)
                if(b) {
                    if(hit_pos) {
                        hit_pos.x = fx < EPSILON ? +ix : ox
                        hit_pos.y = fy < EPSILON ? +iy : oy
                        hit_pos.z = nz < 0 ? iz-EPSILON : iz + 1.0-EPSILON
                    }
                    if(hit_norm) {
                        hit_norm.x = nx
                        hit_norm.y = ny
                        hit_norm.z = nz
                    }
                    return b
                }
            }
        }
        //Walk to next face of cube along ray
        nx = ny = nz = 0
        step = 2.0
        if(dx < -EPSILON) {
            var s = -fx/dx
            nx = 1
            step = s
        }
        if(dx > EPSILON) {
            var s = (1.0-fx)/dx
            nx = -1
            step = s
        }
        if(dy < -EPSILON) {
            var s = -fy/dy
            if(s < step-min_step) {
                nx = 0
                ny = 1
                step = s
            } else if(s < step+min_step) {
                ny = 1
            }
        }
        if(dy > EPSILON) {
            var s = (1.0-fy)/dy
            if(s < step-min_step) {
                nx = 0
                ny = -1
                step = s
            } else if(s < step+min_step) {
                ny = -1
            }
        }
        if(dz < -EPSILON) {
            var s = -fz/dz
            if(s < step-min_step) {
                nx = ny = 0
                nz = 1
                step = s
            } else if(s < step+min_step) {
                nz = 1
            }
        }
        if(dz > EPSILON) {
            var s = (1.0-fz)/dz
            if(s < step-min_step) {
                nx = ny = 0
                nz = -1
                step = s
            } else if(s < step+min_step) {
                nz = -1
            }
        }
        if(step > max_d - t) {
            step = max_d - t - min_step
        }
        if(step < min_step) {
            step = min_step
        }
        t += step
    }
    if(hit_pos) {
        hit_pos.x = ox;
        hit_pos.y = oy;
        hit_pos.z = oz;
    }
    if(hit_norm) {
        hit_norm.x = hit_norm.y = hit_norm.z = 0;
    }
    return 0
}

function startTraceRay(voxelProvider, origin, direction, max_d, hit_pos, hit_norm, EPSILON) {
    // console.log("tracing",origin,direction)
    var px = +origin.x
        , py = +origin.y
        , pz = +origin.z
        , dx = +direction.x
        , dy = +direction.y
        , dz = +direction.z
        , ds = Math.sqrt(dx*dx + dy*dy + dz*dz)
    if(typeof(EPSILON) === "undefined") {
        EPSILON = 1e-8
    }
    if(ds < EPSILON) {
        if(hit_pos) {
            hit_pos.x = hit_pos.y = hit_pos.z
        }
        if(hit_norm) {
            hit_norm.x = hit_norm.y = hit_norm.z
        }
        return 0;
    }
    dx /= ds
    dy /= ds
    dz /= ds
    if(typeof(max_d) === "undefined") {
        max_d = 64.0
    } else {
        max_d = +max_d
    }
    return traceRay_impl(voxelProvider, px, py, pz, dx, dy, dz, max_d, hit_pos, hit_norm, EPSILON)
}

const traceRay = startTraceRay
// module.exports = traceRay


/***/ }),

/***/ "./src/utils.js":
/*!**********************!*\
  !*** ./src/utils.js ***!
  \**********************/
/*! exports provided: toHexColor, generateChunkInfoFromFunction, toRad, EPSILON, $, DIRS, on, traceRayAtScreenCoords, rand */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "toHexColor", function() { return toHexColor; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "generateChunkInfoFromFunction", function() { return generateChunkInfoFromFunction; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "toRad", function() { return toRad; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EPSILON", function() { return EPSILON; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "$", function() { return $; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DIRS", function() { return DIRS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "on", function() { return on; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "traceRayAtScreenCoords", function() { return traceRayAtScreenCoords; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "rand", function() { return rand; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _raycast_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./raycast.js */ "./src/raycast.js");



function toHexColor(num) {
    let str = num.toString(16)
    while(str.length < 6) str = '0' + str
    return '#' + str
}


function generateChunkInfoFromFunction(l, h, f) {
    let d = [ h[0]-l[0], h[1]-l[1], h[2]-l[2] ]
    let v = new Int32Array(d[0]*d[1]*d[2])
    let n = 0;
    for(let k=l[2]; k<h[2]; ++k)
        for(let j=l[1]; j<h[1]; ++j)
            for(let i=l[0]; i<h[0]; ++i, ++n) {
                v[n] = f(i,j,k);
            }
    return {
        low:l,
        high:h,
        voxels:v,
        dims:d,
    };
}


const toRad = (deg) => Math.PI / 180 * deg


const EPSILON = 1e-8


const $ = (sel) => document.querySelector(sel)

const DIRS = {
    NONE:'NONE',
    UP:'UP',
    DOWN:'DOWN',
    LEFT:'LEFT',
    RIGHT:'RIGHT'
}

const on = (elem, type, cb) => elem.addEventListener(type,cb)


function traceRayAtScreenCoords(app, pt, distance) {
    const ray = new three__WEBPACK_IMPORTED_MODULE_0__["Ray"]()

    // e = e.changedTouches[0]
    const mouse = new three__WEBPACK_IMPORTED_MODULE_0__["Vector2"]()
    const bounds = app.renderer.domElement.getBoundingClientRect()
    mouse.x = ((pt.x - bounds.left) / bounds.width) * 2 - 1
    mouse.y = -((pt.y - bounds.top) / bounds.height) * 2 + 1

    ray.origin.copy(app.camera.position)
    ray.direction.set(mouse.x, mouse.y, 0.5).unproject(app.camera).sub(ray.origin).normalize()

    app.stagePos.worldToLocal(ray.origin)
    ray.origin.add(new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,0,-0.5))
    const quat = new three__WEBPACK_IMPORTED_MODULE_0__["Quaternion"]()
    quat.copy(app.stageRot.quaternion)
    quat.inverse()
    ray.direction.applyQuaternion(quat)

    const hitNormal = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,0,0)
    const hitPosition = new three__WEBPACK_IMPORTED_MODULE_0__["Vector3"](0,0,0)
    const hitBlock = Object(_raycast_js__WEBPACK_IMPORTED_MODULE_1__["traceRay"])(app.chunkManager,ray.origin,ray.direction,distance,hitPosition,hitNormal,EPSILON)
    return {
        hitBlock:hitBlock,
        hitPosition:hitPosition,
        hitNormal: hitNormal
    }
}


const rand = (min,max) => Math.random()*(max-min) + min


/***/ }),

/***/ "./src/webxr-boilerplate/Pointer.js":
/*!******************************************!*\
  !*** ./src/webxr-boilerplate/Pointer.js ***!
  \******************************************/
/*! exports provided: POINTER_ENTER, POINTER_EXIT, POINTER_CLICK, POINTER_MOVE, POINTER_PRESS, POINTER_RELEASE, Pointer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "POINTER_ENTER", function() { return POINTER_ENTER; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "POINTER_EXIT", function() { return POINTER_EXIT; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "POINTER_CLICK", function() { return POINTER_CLICK; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "POINTER_MOVE", function() { return POINTER_MOVE; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "POINTER_PRESS", function() { return POINTER_PRESS; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "POINTER_RELEASE", function() { return POINTER_RELEASE; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Pointer", function() { return Pointer; });
/* harmony import */ var _raycaster_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./raycaster.js */ "./src/webxr-boilerplate/raycaster.js");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_1__);



const POINTER_ENTER = "enter"
const POINTER_EXIT = "exit"
const POINTER_CLICK = "click"
const POINTER_MOVE = "move"
const POINTER_PRESS = "press"
const POINTER_RELEASE = "release"


const toRad = (degrees) => degrees*Math.PI/180

class Pointer {
    constructor(app, opts) {
        this.scene = app.scene
        this.renderer = app.renderer
        this.camera = app.camera
        this.listeners = {}
        this.opts = opts || {}
        this.opts.enableLaser = (this.opts.enableLaser !== undefined) ? this.opts.enableLaser : true
        this.opts.laserLength = (this.opts.laserLength !== undefined) ? this.opts.laserLength : 3
        this.canvas = this.renderer.domElement

        this.raycaster = new _raycaster_js__WEBPACK_IMPORTED_MODULE_0__["Raycaster"]()
        this.waitcb = null
        this.hoverTarget = null

        this.intersectionFilter = this.opts.intersectionFilter || ((o) => true)
        this.raycaster.recurseFilter = this.opts.recurseFilter || (()=> true)
        this.multiTarget = this.opts.multiTarget || false


        // setup the mouse
        this.canvas.addEventListener('mousemove', this.mouseMove.bind(this))
        this.canvas.addEventListener('click', this.mouseClick.bind(this))
        this.canvas.addEventListener('mousedown',this.mouseDown.bind(this))
        this.canvas.addEventListener('mouseup',this.mouseUp.bind(this))

        //touch events
        this.canvas.addEventListener('touchstart',this.touchStart.bind(this))
        this.canvas.addEventListener('touchmove',this.touchMove.bind(this))
        this.canvas.addEventListener('touchend',this.touchEnd.bind(this))

        // setup the VR controllers
        this.controller1 = this.renderer.vr.getController(0);
        this.controller1.addEventListener('selectstart', this.controllerSelectStart.bind(this));
        this.controller1.addEventListener('selectend', this.controllerSelectEnd.bind(this));


        this.controller2 = this.renderer.vr.getController(1);
        this.controller2.addEventListener('selectstart', this.controllerSelectStart.bind(this));
        this.controller2.addEventListener('selectend', this.controllerSelectEnd.bind(this));

        this.setMouseSimulatesController(opts.mouseSimulatesController)

        this.scene.add(this.controller1);
        this.scene.add(this.controller2);



        if(this.opts.enableLaser) {
            //create visible lines for the two controllers
            const geometry = new three__WEBPACK_IMPORTED_MODULE_1__["BufferGeometry"]()
            geometry.addAttribute('position', new three__WEBPACK_IMPORTED_MODULE_1__["Float32BufferAttribute"]([0, 0, 0, 0, 0, -this.opts.laserLength], 3));
            geometry.addAttribute('color', new three__WEBPACK_IMPORTED_MODULE_1__["Float32BufferAttribute"]([1.0, 0.5, 0.5, 0, 0, 0], 3));

            const material = new three__WEBPACK_IMPORTED_MODULE_1__["LineBasicMaterial"]({
                vertexColors: false,
                color: 0x880000,
                linewidth: 5,
                blending: three__WEBPACK_IMPORTED_MODULE_1__["NormalBlending"]
            })

            this.controller1.add(new three__WEBPACK_IMPORTED_MODULE_1__["Line"](geometry, material));
            this.controller2.add(new three__WEBPACK_IMPORTED_MODULE_1__["Line"](geometry, material));
        }

    }

    //override this to do something w/ the controllers on every tick
    tick(time) {
        this.controllerMove(this.controller1)
        this.controllerMove(this.controller2)
    }


    fire(obj, type, payload) {
        obj.dispatchEvent(payload)
    }
    fireSelf(type,payload) {
        if(!this.listeners[type]) return
        this.listeners[type].forEach(cb => cb(payload))
    }

    //make the camera follow the mouse in desktop mode. Helps w/ debugging.
    cameraFollowMouse(e) {
        const bounds = this.canvas.getBoundingClientRect()
        const ry = ((e.clientX - bounds.left) / bounds.width) * 2 - 1
        const rx = 1 - ((e.clientY - bounds.top) / bounds.height) * 2
        this.camera.rotation.y = -ry*2
        this.camera.rotation.x = +rx
    }

    mouseMove(e) {
        const mouse = new three__WEBPACK_IMPORTED_MODULE_1__["Vector2"]()
        const bounds = this.canvas.getBoundingClientRect()
        mouse.x = ((e.clientX - bounds.left) / bounds.width) * 2 - 1
        mouse.y = -((e.clientY - bounds.top) / bounds.height) * 2 + 1
        this.raycaster.setFromCamera(mouse, this.camera)
        if(this.opts.mouseSimulatesController) {
            //create target from the mouse controls
            const target = new three__WEBPACK_IMPORTED_MODULE_1__["Vector3"]()
            target.x = mouse.x
            target.y = mouse.y
            target.z = -3
            //convert to camera space
            target.add(this.camera.position)
            this.spot.position.copy(target)
            this.controller1.lookAt(target)
            //have to flip over because the UP is down on controllers
            const flip = new three__WEBPACK_IMPORTED_MODULE_1__["Quaternion"]().setFromAxisAngle(new three__WEBPACK_IMPORTED_MODULE_1__["Vector3"](0,1,0),toRad(180))
            this.controller1.quaternion.multiply(flip)
        }
        this._processMove()

        if(this.opts.cameraFollowMouse) this.cameraFollowMouse(e)
    }

    touchStart(e) {
        e.preventDefault()
        if(e.changedTouches.length <= 0) return
        const tch = e.changedTouches[0]
        const mouse = new three__WEBPACK_IMPORTED_MODULE_1__["Vector2"]()
        const bounds = this.canvas.getBoundingClientRect()
        mouse.x = ((tch.clientX - bounds.left) / bounds.width) * 2 - 1
        mouse.y = -((tch.clientY - bounds.top) / bounds.height) * 2 + 1
        this.raycaster.setFromCamera(mouse, this.camera)
        const intersects = this.raycaster.intersectObjects(this.scene.children, true)
            .filter(it => this.intersectionFilter(it.object))
        intersects.forEach((it,i) => {
            this.fire(it.object, POINTER_PRESS, {type: POINTER_PRESS})
        })
    }
    touchMove(e) {
        e.preventDefault()
        if(e.changedTouches.length <= 0) return
        const tch = e.changedTouches[0]
        const mouse = new three__WEBPACK_IMPORTED_MODULE_1__["Vector2"]()
        const bounds = this.canvas.getBoundingClientRect()
        mouse.x = ((tch.clientX - bounds.left) / bounds.width) * 2 - 1
        mouse.y = -((tch.clientY - bounds.top) / bounds.height) * 2 + 1
        this.raycaster.setFromCamera(mouse, this.camera)
        this._processMove()
    }
    touchEnd(e) {
        e.preventDefault()
        if(e.changedTouches.length <= 0) return
        const tch = e.changedTouches[0]
        const mouse = new three__WEBPACK_IMPORTED_MODULE_1__["Vector2"]()
        const bounds = this.canvas.getBoundingClientRect()
        mouse.x = ((tch.clientX - bounds.left) / bounds.width) * 2 - 1
        mouse.y = -((tch.clientY - bounds.top) / bounds.height) * 2 + 1
        this.raycaster.setFromCamera(mouse, this.camera)
        const intersects = this.raycaster.intersectObjects(this.scene.children, true)
            .filter(it => this.intersectionFilter(it.object))
        intersects.forEach((it) => {
            this.fire(it.object, POINTER_RELEASE, {type: POINTER_RELEASE, point: it.point})
        })
        this._processClick()
    }

    controllerMove(controller) {
        if(!controller.visible) return
        const c = controller
        const dir = new three__WEBPACK_IMPORTED_MODULE_1__["Vector3"](0, 0, -1)
        dir.applyQuaternion(c.quaternion)
        this.raycaster.set(c.position, dir)
        this._processMove()
    }

    _processMove() {
        const intersects = this.raycaster.intersectObjects(this.scene.children, true)
            .filter(it => this.intersectionFilter(it.object))

        if(intersects.length === 0 && this.hoverTarget) {
            this.fire(this.hoverTarget, POINTER_EXIT, {type: POINTER_EXIT})
            this.hoverTarget = null
        }
        if(intersects.length >= 1) {
            const it = intersects[0]
            const obj = it.object
            if (!obj) return
            this.fire(obj, POINTER_MOVE, {type: POINTER_MOVE, point: it.point, intersection:it})
            if (obj === this.hoverTarget) {
                //still inside
            } else {
                if (this.hoverTarget)
                    this.fire(this.hoverTarget, POINTER_EXIT, {type: POINTER_EXIT})
                this.hoverTarget = obj
                this.fire(this.hoverTarget, POINTER_ENTER, {type: POINTER_ENTER})
            }
        }
    }

    _processClick() {
        if (this.waitcb) {
            this.waitcb()
            this.waitcb = null
            return
        }

        const intersects = this.raycaster.intersectObjects(this.scene.children, true)
            .filter(it => this.intersectionFilter(it.object))
        if(intersects.length > 0) {
            const it = intersects[0]
            this.fire(it.object, POINTER_CLICK, {type: POINTER_CLICK, point: it.point, intersection:it})
        } else {
            this.fireSelf(POINTER_CLICK, {type: POINTER_CLICK})
        }
    }
    mouseClick(e) {
        const mouse = new three__WEBPACK_IMPORTED_MODULE_1__["Vector2"]()
        const bounds = this.canvas.getBoundingClientRect()
        mouse.x = ((e.clientX - bounds.left) / bounds.width) * 2 - 1
        mouse.y = -((e.clientY - bounds.top) / bounds.height) * 2 + 1
        this.raycaster.setFromCamera(mouse, this.camera)
        this._processClick()
    }
    mouseDown(e) {
        const mouse = new three__WEBPACK_IMPORTED_MODULE_1__["Vector2"]()
        const bounds = this.canvas.getBoundingClientRect()
        mouse.x = ((e.clientX - bounds.left) / bounds.width) * 2 - 1
        mouse.y = -((e.clientY - bounds.top) / bounds.height) * 2 + 1
        this.raycaster.setFromCamera(mouse, this.camera)
        const intersects = this.raycaster.intersectObjects(this.scene.children, true)
            .filter(it => this.intersectionFilter(it.object))

        intersects.forEach((it,i) => {
            if(!this.multiTarget && i > 0) return
            this.fire(it.object, POINTER_PRESS, {type: POINTER_PRESS, point: it.point, intersection:it})
        })
    }
    mouseUp(e) {
        const mouse = new three__WEBPACK_IMPORTED_MODULE_1__["Vector2"]()
        const bounds = this.canvas.getBoundingClientRect()
        mouse.x = ((e.clientX - bounds.left) / bounds.width) * 2 - 1
        mouse.y = -((e.clientY - bounds.top) / bounds.height) * 2 + 1
        this.raycaster.setFromCamera(mouse, this.camera)
        const intersects = this.raycaster.intersectObjects(this.scene.children, true)
            .filter(it => this.intersectionFilter(it.object))
        intersects.forEach((it,i) => {
            if(!this.multiTarget && i > 0) return //skip all but the first
            this.fire(it.object, POINTER_RELEASE, {type: POINTER_RELEASE, point: it.point, intersection:it})
        })
    }

    controllerSelectStart(e) {
        e.target.userData.isSelecting = true;
        const intersects = this.raycaster.intersectObjects(this.scene.children, true)
            .filter(it => this.intersectionFilter(it.object))
        intersects.forEach((it,i) => {
            if(!this.multiTarget && i > 0) return //skip all but the first
            this.fire(it.object, POINTER_PRESS, {type: POINTER_PRESS, point: it.point, intersection:it})
        })
    }

    controllerSelectEnd(e) {
        e.target.userData.isSelecting = false;
        const c = e.target
        const dir = new three__WEBPACK_IMPORTED_MODULE_1__["Vector3"](0, 0, -1)
        dir.applyQuaternion(c.quaternion)
        this.raycaster.set(c.position, dir)
        const intersects = this.raycaster.intersectObjects(this.scene.children, true)
            .filter(it => this.intersectionFilter(it.object))
        intersects.forEach((it,i) => {
            if(!this.multiTarget && i > 0) return //skip all but the first
            this.fire(it.object, POINTER_RELEASE, {type: POINTER_RELEASE, point: it.point})
        })
        this._processClick()
    }

    waitSceneClick(cb) {
        this.waitcb = cb
    }


    addEventListener(type,cb) {
        this.on(type,cb)
    }
    on(type,cb) {
        if(!this.listeners[type]) this.listeners[type] = []
        this.listeners[type].push(cb)
    }
    off(type,cb) {
        this.listeners[type] = this.listeners[type].filter(c => c !== cb)
    }
    setMouseSimulatesController(val) {
        this.opts.mouseSimulatesController = val
        if(this.opts.mouseSimulatesController) {
            this.controller1 = new Group()
            this.controller1.position.set(0,1,-2)
            this.controller1.quaternion.setFromUnitVectors(three__WEBPACK_IMPORTED_MODULE_1__["Object3D"].DefaultUp, new three__WEBPACK_IMPORTED_MODULE_1__["Vector3"](0,0,1))
            this.spot = new three__WEBPACK_IMPORTED_MODULE_1__["Mesh"](
                new three__WEBPACK_IMPORTED_MODULE_1__["SphereBufferGeometry"](0.1),
                new three__WEBPACK_IMPORTED_MODULE_1__["MeshLambertMaterial"]({color: 'red'})
            )
            this.scene.add(this.spot)
        } else {
        }

    }
}


/***/ }),

/***/ "./src/webxr-boilerplate/raycaster.js":
/*!********************************************!*\
  !*** ./src/webxr-boilerplate/raycaster.js ***!
  \********************************************/
/*! exports provided: Raycaster */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Raycaster", function() { return Raycaster; });
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! three */ "three");
/* harmony import */ var three__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(three__WEBPACK_IMPORTED_MODULE_0__);


/**
 * @author mrdoob / http://mrdoob.com/
 * @author bhouston / http://clara.io/
 * @author stephomi / http://stephaneginier.com/
 */

function Raycaster( origin, direction, near, far ) {

    this.ray = new three__WEBPACK_IMPORTED_MODULE_0__["Ray"]( origin, direction );
    // direction is assumed to be normalized (for accurate distance calculations)

    this.near = near || 0;
    this.far = far || Infinity;

    this.params = {
        Mesh: {},
        Line: {},
        LOD: {},
        Points: { threshold: 1 },
        Sprite: {}
    };

    Object.defineProperties( this.params, {
        PointCloud: {
            get: function () {

                console.warn( 'THREE.Raycaster: params.PointCloud has been renamed to params.Points.' );
                return this.Points;

            }
        }
    } );

}

function ascSort( a, b ) {

    return a.distance - b.distance;

}

let count = 0

function intersectObject( object, raycaster, intersects, recursive ) {

    if ( object.visible === false ) return;
    if(raycaster.recurseFilter && !raycaster.recurseFilter(object)) return;

    count++
    object.raycast( raycaster, intersects );

    if ( recursive === true ) {

        var children = object.children;

        for ( var i = 0, l = children.length; i < l; i ++ ) {

            intersectObject( children[ i ], raycaster, intersects, true );

        }

    }

}

Object.assign( Raycaster.prototype, {

    linePrecision: 1,

    set: function ( origin, direction ) {

        // direction is assumed to be normalized (for accurate distance calculations)

        this.ray.set( origin, direction );

    },

    setFromCamera: function ( coords, camera ) {

        if ( ( camera && camera.isPerspectiveCamera ) ) {

            this.ray.origin.setFromMatrixPosition( camera.matrixWorld );
            this.ray.direction.set( coords.x, coords.y, 0.5 ).unproject( camera ).sub( this.ray.origin ).normalize();

        } else if ( ( camera && camera.isOrthographicCamera ) ) {

            this.ray.origin.set( coords.x, coords.y, ( camera.near + camera.far ) / ( camera.near - camera.far ) ).unproject( camera ); // set origin in plane of camera
            this.ray.direction.set( 0, 0, - 1 ).transformDirection( camera.matrixWorld );

        } else {

            console.error( 'THREE.Raycaster: Unsupported camera type.' );

        }

    },

    intersectObject: function ( object, recursive, optionalTarget ) {

        var intersects = optionalTarget || [];

        intersectObject( object, this, intersects, recursive);

        intersects.sort( ascSort );

        return intersects;

    },

    intersectObjects: function ( objects, recursive, optionalTarget ) {
        count = 0
        var intersects = optionalTarget || [];

        if ( Array.isArray( objects ) === false ) {

            console.warn( 'THREE.Raycaster.intersectObjects: objects is not an Array.' );
            return intersects;

        }

        for ( var i = 0, l = objects.length; i < l; i ++ ) {

            intersectObject( objects[ i ], this, intersects, recursive);

        }

        // console.log("intersected objects",count)

        intersects.sort( ascSort );

        return intersects;

    }

} );





/***/ }),

/***/ "ecsy":
/*!********************************************************************!*\
  !*** external {"commonjs":"ecsy","commonjs2":"ecsy","amd":"ecsy"} ***!
  \********************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = undefined;

/***/ }),

/***/ "ecsy-three":
/*!**************************************************************************************!*\
  !*** external {"commonjs":"ecsy-three","commonjs2":"ecsy-three","amd":"ecsy-three"} ***!
  \**************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = undefined;

/***/ }),

/***/ "three":
/*!***********************************************************************!*\
  !*** external {"commonjs":"three","commonjs2":"three","amd":"three"} ***!
  \***********************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = undefined;

/***/ })

/******/ });
//# sourceMappingURL=voxeljs-next.js.map